#! ..\perl-5.8.6\bin\perl

##! perl

######################################################################
# satpro.cgi
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Walter Sobkiw.  All Rights Reserved.
# By using this program you agree to indemnify Walter Sobkiw and 
# cassbeth from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# VERSION HISTORY:

# 1.0 10/08/07
# fixed exit added stop
# added directory instructions
# removed protexis
# added count expiration to demo

# 1.1 12/01/07
# added LDA, DEV, and DVA
# updated default keys
# added .{25,} to noise words pattern
# removed service PUI artifact

# 1.2 10/18/08
# added book and removed 2009 expiration

# 1.3 02/21/09
# added AND with object
# updated APACHE to show full file name

# 1.4 03/10/09
# fixed problem associated with AND object

# 1.5 02/16/13
# updated demo keys and added demo keys link
# added other two book image
# updated installed company info to be CassBeth
# updated Apache to include FMT in conf file

# 0.4.8 07/17/07 NEW
## template import and export
## embebed product labeling into pck.txt
## fix disable analysis for children
## set default template

$version = "1.5";
######################################################################

# Define Variables
$g_maxdata    = 131072;    # maximum bytes to accept via POST - 2^17
$g_maxdata    = 20000000;  # maximum bytes to accept via POST - 2^17
$g_writefiles = 0;         # directory to which to write files, or
                           # 0 if files should not be written
$g_filepre    = "spec";    # Prefix of file names, in directory above

# Do not change the following parameters unless you have special reasons
$g_bufsize  =  8192;    # default buffer size when reading multipart
$g_maxbound =   100;    # maximum boundary length to be encounterd

$script = $ENV{'SCRIPT_NAME'};
$script =~ s/(.*)\/(.*)$/$2/;
$product = $1;

$url = "$ENV{'HTTP_REFERER'}";
$url =~ s/(.*)(~...)(.*)/http:\/\/localhost:4444\/$2/;

if (!$script) {$script = "satpro.cgi";}
if (!$url)    {$url = "http://localhost:4444$product";}

$script = "$url/$script";

if ($url =~ /sat/) {$tui = "SAT"; $toolname = "Specification Analysis Tool"; $prod = 0;}
if ($url =~ /gda/) {$tui = "GDA"; $toolname = "General Document Analysis"; $prod = 741;}
if ($url =~ /lda/) {$tui = "LDA"; $toolname = "Legal Document Analysis"; $prod = 936;}
if ($url =~ /lat/) {$tui = "LAT"; $toolname = "Legislative Analysis Tool"; $prod = 12121;}
if ($url =~ /cat/) {$tui = "CAT"; $toolname = "Constitutional Analysis Tool"; $prod = 3121;}
if ($url =~ /pla/) {$tui = "PLA"; $toolname = "Plain Language Analysis Tool"; $prod = 31712;}
if ($url =~ /dev/) {$tui = "DEV"; $toolname = "CassBeth Z-Framework"; $prod = 852;}
if ($url =~ /mta/) {$tui = "MTA"; $toolname = "Medical Transcript Analysis"; $prod = 963;}
if ($url =~ /dva/) {$tui = "DVA"; $toolname = "Data Visualization Analysis"; $prod = 985;}

$d_noise  = ".{25,}|  +| . | \\d+ | the | of | a | in | by | as | was | it ";
$d_noise .= "| this | that | these | as | there | their | on | was | then ";
$d_noise .= "| it | for | were | was | which | such ";
$d_noise .= "| and | too? | be | or | with | all ";
$d_noise .= "| each | into | from | if | an | upon ";
$d_noise .= "| shall | will | should | could | might | may ";
$d_noise .= "| more | at | they | them | other | against ";
$d_noise .= "| have | so | having | any | make ";

$d_noise .= "| chosen | had | every | report | directed | provide ";
$d_noise .= "| meet | not | how | would | place | promptly ";
$d_noise .= "| like | been | take | but | order | already | who | done | when | over ";
$d_noise .= "| taken | after | be | put | except | exception ";
$d_noise .= "| particular | no | those | day | become | ourselves | form | consist ";
$d_noise .= "| appear | our | use | providing | under | whole ";
$d_noise .= "| do | than | most | nothing | proceed | only | cannot | some ";
$d_noise .= "| is | are | has | does | it.? ";
$d_noise .= "| must | per | within | see | using | where | about ";
$d_noise .= "| also | above ";

#$d_noise .= "|,|\\;|:|\\.|\\?|\\(|\\)|\\{|\\}|\\[|\\]";

$| = 1;

####################

#BEGIN {
#   use CGI::Carp qw(carpout);
#   open(LOG, ">>error-cgi.log") or die("Unable to open mycgi-log: $!\n");
#   carpout(LOG);
#}

use CGI::Carp qw(fatalsToBrowser);

print "Content-type: text/html\n\n";

&get_date;
$starttime = "$hour:$min:$sec";
$startsec = $hour*3600+$min*60+$sec;

# Read in all the variables set by the form
&ReadParse(*input);

if ($input{'stopnow'}) {&stopnow;}

if ($input{'shutdown'}) {&shutdown;}

if (!$input{'tmplttitle'}) {$input{'tmplttitle'} = "Default Template";}

&log;

#print "script $script<P>";

print <<END_HTMLSTART;
<HTML>
<HEAD>
<TITLE>$input{'tmplttitle'}</TITLE>
</HEAD>
<BODY>
<TABLE CELLPADDING="2">
<TR VALIGN="TOP">
<TD><A HREF="$script"><IMG WIDTH="172" HEIGHT="59" SRC="cassbeth.gif" ALT="If this is a template Press Submit first" BORDER="0"></A></TD>
<TD><H2><FONT COLOR='GREEN'>$toolname</FONT></H2></TD>
<TD><FONT COLOR='RED'>$demo</FONT></TD>
<TD><SMALL>
<A HREF='documents' TARGET='lib'>Documents</A><BR>
<A HREF='templates' TARGET='lib'>Templates</A><BR>
<A HREF='previous-analysis' TARGET='lib'>History</A><BR>
<BR>
</SMALL></TD>
<TD> </TD>
<TD><SMALL>
<A HREF='help.html' TARGET='HELP'>Help</A><BR>
<A HREF='regex.html' TARGET='HELP'>REs</A><BR>
<A HREF='demo-reports' TARGET='lib'>Training</A><BR>
</SMALL></TD>
</TR>
</TABLE>
END_HTMLSTART

# default services
&default_services;

# default rules
&default_rules;

if ($input{'tmpltdescrip'}) {
   print "<H2>$input{'tmplttitle'}</H2><P>";
   print "$input{'tmpltdescrip'}<P>";
}

print "<form method='POST' enctype='multipart/form-data' action='$script'>\n";

print "<TABLE><TR VALIGN='TOP'><TD>\n";
print "ReStart <A HREF='$url'>Default Rules</A> ";
print "<A HREF='$script?restart=y'>No Rules</A> ";
print "<P>Prior to <A HREF='help.html#File to upload' TARGET='HELP'>uploading your file</A>, 
set your report options.<BR>
Also check the rules and modify them as desired.<BR>\n
<INPUT TYPE='file' NAME='upfile' VALUE='$file' SIZE='40'>\n";
print "<P>";
print "<INPUT TYPE='submit' VALUE='Submit'> ";
print "<INPUT TYPE='submit' NAME='shutdown' VALUE='Exit'> &nbsp; &nbsp; &nbsp; ";
print "<A HREF='satpro.cgi?stopnow=$$' TARGET='stopnow'>Stop Now</A> ";
print "</TD>";
if ($input{'tmpltinstrct'}) {$wewe = "f0f0f0";}
print "<TD> </TD><TD BGCOLOR='$wewe'><SMALL>$input{'tmpltinstrct'}</SMALL></TD>";
if ($keydate =~ /book|demo/i) {
   print "<TD><CENTER><A HREF='http://www.cassbeth.com/book/index.html' TARGET='_blank'><IMG SRC='b1.jpg' BORDER='0' ALT='Sustainable Development Possible with Creative System Engineering buy from amazon.com'><BR>Book Information</A></CENTER></TD>";
}
print "</TR></TABLE>\n";

if ($incfn{'upfile'}) {
   print "New File: <A HREF='temp/spec.tmp' TARGET='FILE'>$incfn{'upfile'}</A> ";
   #if ($incfn{'upfile'} =~ /\.htm/i) {$input{'striphtml'} = "CHECKED";}
}
if ($input{'file'}) {print "Previously Uploaded File: <A HREF='temp/spec.tmp' TARGET='FILE'>$input{'file'}</A> ";}
print "<P>\n";

print "<TABLE><TR VALIGN='TOP'><TD>";
print "<B>Analysis Settings</B> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hidesettings' VALUE='CHECKED' $input{'hidesettings'}> Hide</SMALL> ";
print "\n";
if (!$input{'hidesettings'}) {
print "<P>
<INPUT TYPE='text' NAME='puimask' VALUE='$input{'puimask'}' SIZE='20'> <A HREF='help.html#PUI Mask' TARGET='HELP'>PUI Mask</A><BR>
<INPUT TYPE='text' NAME='imperatives' VALUE='$input{'imperatives'}' SIZE='20'> <A HREF='help.html#Imperatives' TARGET='HELP'>Imperatives</A><BR>
<INPUT TYPE='checkbox' NAME='rptshalls' VALUE='CHECKED' $input{'rptshalls'}> <A HREF='help.html#Process Only Imperatives' TARGET='HELP'>Process Only Imperatives</A><BR>
</TD><TD><BR>
<INPUT TYPE='checkbox' NAME='parsetxt' VALUE='CHECKED' $input{'parsetxt'}> <A HREF='help.html#Parse Text' TARGET='HELP'>Parse Text</A>
";

if ($input{'parsetxt'}) {print "<SMALL><INPUT TYPE='checkbox' NAME='rptrulespt' VALUE='CHECKED' $input{\"rptrulespt\"}> Show Rules </SMALL>\n";}
if ($input{'rptrulespt'}) {
print "
<BR>
case sensitive
<BR>
<INPUT TYPE='text' NAME='ptaccess' VALUE='$input{'ptaccess'}' SIZE='20'> <A HREF='help.html#Access' TARGET='HELP'>Access</A><BR>
<INPUT TYPE='text' NAME='ptreject' VALUE='$input{'ptreject'}' SIZE='20'> <A HREF='help.html#Reject' TARGET='HELP'>Reject</A><BR>
<INPUT TYPE='text' NAME='ptstart' VALUE='$input{'ptstart'}' SIZE='20'> <A HREF='help.html#Chop Top' TARGET='HELP'>Chop Top</A><BR>
<INPUT TYPE='text' NAME='ptend' VALUE='$input{'ptend'}' SIZE='20'> <A HREF='help.html#Chop End' TARGET='HELP'>Chop End</A><BR>
<INPUT TYPE='checkbox' NAME='ptole' VALUE='CHECKED' $input{'ptole'}> <A HREF='help.html#Parse Text OLE' TARGET='HELP'>MsWord OLE</A><P>
";
}
if (!$input{'rptrulespt'}) {
print "
<INPUT TYPE='hidden' NAME='ptaccess' VALUE='$input{'ptaccess'}'>
<INPUT TYPE='hidden' NAME='ptreject' VALUE='$input{'ptreject'}'>
<INPUT TYPE='hidden' NAME='ptstart' VALUE='$input{'ptstart'}'>
<INPUT TYPE='hidden' NAME='ptend' VALUE='$input{'ptend'}'>
<INPUT TYPE='hidden' NAME='ptole' VALUE='$input{'ptole'}'>
";
}

print "
<BR>
<INPUT TYPE='checkbox' NAME='striphtml' VALUE='CHECKED' $input{'striphtml'}> <A HREF='help.html#Strip HTML Tags' TARGET='HELP'>Strip HTML Tags</A><BR>
<INPUT TYPE='checkbox' NAME='stripblkl' VALUE='CHECKED' $input{'stripblkl'}> <A HREF='help.html#Strip Blank Lines' TARGET='HELP'>Strip Blank Lines</A><BR>
<INPUT TYPE='checkbox' NAME='showupld' VALUE='CHECKED' $input{'showupld'}> <A HREF='help.html#Show Processed Upload' TARGET='HELP'>Show Processed Upload</A><BR>
</TD>
\n";
}

print "<TD>\n";

print "<TD><B>Report Areas</B>
<SMALL><INPUT TYPE='checkbox' NAME='hidelib' VALUE='CHECKED' $input{'hidelib'}> Hide</SMALL>";

if (!$input{'hidelib'}) {
print "
<BR>
<A HREF='#analysisresults'>Analysis Results</A><BR>
<A HREF='#accessedwords'>Accessed Words</A><BR>
<A HREF='#accessedpatternsfound'>Accessed Patterns</A><BR>
<A HREF='#metrics'>Metrics</A><BR>
</TD>
<TD>
<BR>
<A HREF='#shape'>Doc Shape</A><BR>
<A HREF='#readinglevel'>Reading Level</A><BR>
<A HREF='#comments'>Comments</A><BR>
<BR>
\n";

}

print "</TD></TR></TABLE><P>\n";

if ($input{'hidesettings'}) {
print "
<INPUT TYPE='hidden' NAME='puimask' VALUE='$input{'puimask'}'>
<INPUT TYPE='hidden' NAME='imperatives' VALUE='$input{'imperatives'}'>
<INPUT TYPE='hidden' NAME='rptshalls' VALUE='$input{'rptshalls'}'>
<INPUT TYPE='hidden' NAME='parsetxt' VALUE='$input{'parsetxt'}'>
<INPUT TYPE='hidden' NAME='rptrulespt' VALUE='$input{'rptrulespt'}'>

<INPUT TYPE='hidden' NAME='ptaccess' VALUE='$input{'ptaccess'}'>
<INPUT TYPE='hidden' NAME='ptreject' VALUE='$input{'ptreject'}'>
<INPUT TYPE='hidden' NAME='ptstart' VALUE='$input{'ptstart'}'>
<INPUT TYPE='hidden' NAME='ptend' VALUE='$input{'ptend'}'>
<INPUT TYPE='hidden' NAME='ptole' VALUE='$input{'ptole'}'>

<INPUT TYPE='hidden' NAME='striphtml' VALUE='$input{'striphtml'}'>
<INPUT TYPE='hidden' NAME='stripblkl' VALUE='$input{'stripblkl'}'>
<INPUT TYPE='hidden' NAME='showupld' VALUE='$input{'showupld'}'>
\n";
}

print "<B>Services and Rules</B><P>";

# report services
&service_menu;

print "<P><HR><P>";

# process file
&process;

# Accessed Words
&accessed_words;

# Accessed Patterns
&accessed_patterns;

# calculate metrics
&metrics;

# document shape
&shape;

# service and rule comments
&comments;

# Show uploaded file
#($text = $input{'upfile'}) =~ s/\n/\n<BR>/g; 
#print "<P>$text<P>";

# Show all variables
#print &PrintVariables(*input);
#foreach $word (keys %input) {print "HI $word -- $input{$word}<BR>\n";}
#print "Uploaded File Name: $incfn{'upfile'}<BR>";

# env variables
#foreach $word (keys %ENV) {print "$word $ENV{$word}<br>";}

# clean p2xtmp-$$ files
$temp_dir = ( $ENV{TEMP} || $ENV{TMP} || $ENV{WINDIR} || '/tmp' );
$temp_dir =~ s/\\/\//g;
if ($temp_dir) {&clean_temp;}

# error pid
$file = "../apache/logs/error.log";
open(SA,"$file");
@pidc = <SA>;
close(SA);
$pidc = $pidc[$#pidc];
if ($pidc =~ /child\s*(-?\d+)/i) {$pidc = $1;}

# httpd pid
$file = "../apache/logs/httpd.pid";
open(SA,"$file");
$pidb = <SA>;
close(SA);

&get_date;
$endtime = "$hour:$min:$sec";
$endsec = $hour*3600+$min*60+$sec;
$sec = $endsec - $startsec;

print <<END_HTMLCLOSE;
</FORM>
<P>
<SMALL><A HREF='help.html#original processing URL' TARGET='HELP'> original processing URL</A> 
$script v $version p
<P>
$starttime Start Time<BR>
$endtime End Time<BR>
$sec Seconds<P>
<SMALL>$] satpro pid: $$ $temp_dir httpd pid:$pidb error pid: $pidc</SMALL>
</SMALL>
<P>
<FONT COLOR='RED'>$demo</FONT>
<P>
END_HTMLCLOSE

print "</BODY></HTML>";

exit;

####################
sub stopnow {

$status = kill 9, $input{'stopnow'};
print "Stopping Analysis $input{'stopnow'} $status<P>\n";
print "Close this window<BR><BR><BR><BR><BR>\n";

print "<HR>";

exit;

}

####################
sub shutdown {

if ($input{shutdown} !~ /apache/) {
   print "Thank You.<P>
   Please <A HREF='$script?shutdown=apache'>SELECT here to Stop the Web server</A>,<P>THEN close this browser window.";
}

if ($input{shutdown} =~ /apache/) {

# httpd pid
$file = "../apache/logs/httpd.pid";
open(SA,"$file");
$pida = <SA>;
close(SA);
$status = unlink $file;
print "Apache Started with PID: $pida $file $status<BR>";
$status = kill 9, $pida;
print "Stopping Apache $pida $status<P>\n";

# error pid
$file = "../apache/logs/error.log";
open(SA,"$file");
@pidc = <SA>;
close(SA);
$pidc = $pidc[$#pidc];
if ($pidc =~ /Child\s*(-?\d+)/i) {$pidc = $1;}
$status = unlink $file;

print "Apache Started with Child PID: $pidc $status $file<BR>";
$status = kill 9, $pidc;
print "Stopping Apache Child $pidc $status<P>\n";

#print "Please close your Browser Now ... Bye\n";

# httpd pid
$file = "../apache/logs/httpd.pid";
open(SA,"$file");
$pida = <SA>;
close(SA);
$status = unlink $file;

print "Apache Started with PID: $pida $status $file<BR>";
$status = kill 9, $pida;
print "Stopping Apache $pida $status<P>\n";

print "You can now close your browser.<P>";

$| = 1;

}

exit;

}

####################
sub clean_temp {

#$temp_dir= "C:/p2xwalt";
@dirs = $temp_dir;

while (@dirs) {
   $dir = shift(@dirs);
   opendir(DIR, $dir) || next;
   while (defined($f = readdir(DIR))) {
      if (-d "$dir/$f" && $f ne "." && $f ne "..") {
         # directory
         $wewe = "$dir/$f";
         if ($wewe !~ /p2xtmp/) {next;}
	   push(@dirs, "$dir/$f");
         push(@dirs_1, "$dir/$f");
      } 
      elsif (-f "$dir/$f") {
         if ($dir !~ /p2xtmp/) {next;}
         push(@files, "$dir/$f");
      }
   }
   closedir(DIR);
}
#print "clean: $temp_dir<P>";
foreach $word (@files) {
   if ($word =~ /$$/) {next;}
   #print "files: $word ";
   if ($word =~ /p2xtmp/) {
      $status = unlink $word;
      #print "status: $status<BR>";
   }
}
#print "<P>";
foreach $word (@dirs_1) {
   if ($word =~ /$$/) {next;}
   #print "dirs_1: $word ";
   if ($word =~ /p2xtmp/) {
      $status = rmdir $word;
      #print "status: $status<BR>";
   }
}

}

####################
sub service_menu {

# Template description
print "<INPUT TYPE='checkbox' NAME='rpttmplt' VALUE='CHECKED' $input{'rpttmplt'}> <A HREF='help.html#Template Comments' TARGET='HELP'>Template Comments</A> $input{tmplttitle}<P>\n";
if ($input{'rpttmplt'}) {
   print "<B>Title</B><BR>";
   print "<INPUT TYPE='text' NAME='tmplttitle' VALUE='$input{'tmplttitle'}' SIZE='30'><P>\n";

   print "<B>Description</B><BR>";
   print "<TEXTAREA NAME='tmpltdescrip' WRAP=VIRTUAL ROWS='6' COLS='90'>$input{'tmpltdescrip'}</TEXTAREA><P>\n";

   print "<B>Instructions</B><BR>";
   print "<TEXTAREA NAME='tmpltinstrct' WRAP=VIRTUAL ROWS='6' COLS='90'>$input{'tmpltinstrct'}</TEXTAREA><P>\n";
}
if (!$input{'rpttmplt'}) {
   if ($input{'tmplttitle'}) {print "<INPUT TYPE='hidden' NAME='tmplttitle' VALUE='$input{'tmplttitle'}'>\n";}
   if ($input{'tmpltdescrip'}) {print "<INPUT TYPE='hidden' NAME='tmpltdescrip' VALUE='$input{'tmpltdescrip'}'>\n";}
   if ($input{'tmpltinstrct'}) {print "<INPUT TYPE='hidden' NAME='tmpltinstrct' VALUE='$input{'tmpltinstrct'}'>\n";}
}

# each service
for ($i = 1; $i <= 20; ++$i) {

# add new service
if ($input{"srvcrmv$i"}) {$input{"srvcname$i"} = ""};
if (!$input{"srvcname$i"}) {
   $wewe = $i-1;
   print "<P><INPUT TYPE='checkbox' NAME='srvc$i' VALUE='CHECKED' $input{\"srvc$i\"}> <B>$input{\"srvcname$i\"}</B>\n";
   print "<A HREF='help.html#Add New Service Name' TARGET='HELP'>Add New Service Name</A> \n";
   if ($i > 3) {
      print "<INPUT TYPE='checkbox' NAME='srvcrmv$wewe' VALUE='CHECKED'> \n";
      print "Remove Last Service: <I>$input{\"srvcname$wewe\"}</I>\n";
   }
   if ($input{"srvc$i"}) {
      print "<P>New Service Name <INPUT TYPE='text' NAME='srvcname$i' VALUE='$input{\"srvcname$i\"}' SIZE='30'>\n";
      $input{"srvcpui$i"} = "s$i"."s";
      if ($input{"srvcpui$i"}) {print "<INPUT TYPE='hidden' NAME='srvcpui$i' VALUE='$input{\"srvcpui$i\"}'>\n";}
   }
   last;
}

# service display filter settings
#print "<INPUT TYPE='checkbox' NAME='srvc$i' VALUE='CHECKED' $input{\"srvc$i\"}> <A HREF='help.html#$input{\"srvcname$i\"}' TARGET='HELP'>$input{\"srvcname$i\"}</A> $input{\"srvcpui$i\"}\n";
print "<INPUT TYPE='checkbox' NAME='srvc$i' VALUE='CHECKED' $input{\"srvc$i\"}> <A HREF='help.html#$input{\"srvcname$i\"}' TARGET='HELP'>$input{\"srvcname$i\"}</A>\n";
#if ($input{"srvcname$i"}) {print "<INPUT TYPE='hidden' NAME='srvcname$i' VALUE='$input{\"srvcname$i\"}'>\n";}
if ($input{"srvcpui$i"}) {print "<INPUT TYPE='hidden' NAME='srvcpui$i' VALUE='$input{\"srvcpui$i\"}'>\n";}

$s = $input{"srvcpui$i"};
$s =~ s/rta//;

# rule display filter settings enabled
if ($input{"srvc$i"}) {
   print "<SMALL><INPUT TYPE='checkbox' NAME='rptruless$i$s' VALUE='CHECKED' $input{\"rptruless$i$s\"}> Show Search\n";
   print "<INPUT TYPE='checkbox' NAME='rptrules$i$s' VALUE='CHECKED' $input{\"rptrules$i$s\"}> Show Simple Rules \n";
   print "<INPUT TYPE='checkbox' NAME='rptrulesc$i$s' VALUE='CHECKED' $input{\"rptrulesc$i$s\"}> Show Complex Rules<BR>\n";
   print "</SMALL><TABLE><TR><TD> . . . </TD><TD><TABLE>\n";
   $column = 0;
   for ($ii = 1; $ii <= 99; ++$ii) {
     if (!$input{"name$ii$s"}) {last;}

     #$metric{"$input{\"name$ii$s\"} <FONT COLOR='$input{\"color$ii$s\"}'>$s</FONT>"}++;
     $metric{"$input{\"name$ii$s\"} <FONT COLOR='$input{\"color$ii$s\"}'>$input{\"srvcpui$i\"}</FONT>"}++;

     # show rule display filters
     if ($column == 0) {print "<TR>\n";}
     print "<TD><INPUT TYPE='checkbox' NAME='rpt$ii$s' VALUE='CHECKED' $input{\"rpt$ii$s\"}> <A HREF='#$input{\"name$ii$s\"}'><FONT COLOR='$input{\"color$ii$s\"}'>$input{\"name$ii$s\"}</FONT></A> <\/TD>\n";
     if ($column++ >= 4) {print "</TR>\n\n"; $column = 0;}

     # find all access patterns
     if ( ($input{"access$ii$s"}) || ($input{"countpat$ii$s"}) ) {
        $allaccesspat .= "$input{\"access$ii$s\"}|";
        @words = split(/\|/,$input{"access$ii$s"});
        foreach $word (@words) {
           $allaccesspatcolor{"$word"} = $input{"color$ii$s"};
        }
     }

   }
   print "</TABLE></TD></TR></TABLE>\n";
}
# rule display filter settings disabled
else {
   for ($ii = 1; $ii <= 99; ++$ii) {
      if (!$input{"name$ii$s"}) {last;}
      if ($input{"rpt$ii$s"}) {print "<INPUT TYPE='hidden' NAME='rpt$ii$s' VALUE='$input{\"rpt$ii$s\"}'>\n";}
   }
}
print "</SMALL><BR>";

# format all access patterns
$allaccesspat =~ s/\|$//;
$allaccesspat =~ s/\|\|/\|/g;
@allaccesspat = split (/\|/, $allaccesspat);

# show rule attributes
&rule_menu;

}


}

####################
sub rule_menu {

# shown rule attributes menu
if ( ($input{"rptrules$i$s"}) || ($input{"rptruless$i$s"}) || ($input{"rptrulesc$i$s"}) ) {

if ($s =~ /rptdup/) {
   print "<INPUT TYPE='text' NAME='mask1$s' VALUE='$input{\"mask1$s\"}' SIZE='60'> Mask Patterns<P>\n";
   if ($input{"name1$s"}) {print "<INPUT TYPE='hidden' NAME='name1$s' VALUE='$input{\"name1$s\"}'>\n";}
   if ($input{"accessaw$s"}) {print "<INPUT TYPE='hidden' NAME='accessaw$s' VALUE='$input{\"accessaw$s\"}'>\n";}
   #next;
}

if ( ($input{"rptrules$i$s"}) || ($input{"rptrulesc$i$s"}) ) {
print "<B>Service Name</B><BR>";
print "<INPUT TYPE='text' NAME='srvcname$i' VALUE='$input{\"srvcname$i\"}' SIZE='20'><BR>\n";

print "<B>Service Description</B><BR>";
print "<TEXTAREA NAME='srvcdescrip$s' WRAP=VIRTUAL ROWS='3' COLS='60'>$input{\"srvcdescrip$s\"}</TEXTAREA><P>\n";
}

for ($irm = 1; $irm <= 99; ++$irm) {

if ($s =~ /rptdup/) {last;}

if ( ($input{"rptruless$i$s"}) && (!$input{"rptrules$i$s"}) ) {
   if (!$input{"name$irm$s"}) {last;}
   print "<FONT COLOR='$input{\"color$irm$s\"}'>\n";
   print "<INPUT TYPE='text' NAME='access$irm$s' VALUE='$input{\"access$irm$s\"}' SIZE='60'> Access Object<BR>\n";
   print "</FONT>\n";
}

if ($input{"rptrules$i$s"}) {

if (!$input{"name$irm$s"}) {print "<B>New</B> $input{\"srvcname$i\"} \n";}
print "<FONT COLOR='$input{\"color$irm$s\"}'>\n";
print "Rule $irm <BR>\n";
print "<INPUT TYPE='text' NAME='name$irm$s' VALUE='$input{\"name$irm$s\"}' SIZE='30'> Name \n";
print "<BR>\n";
print "<INPUT TYPE='text' NAME='color$irm$s' VALUE='$input{\"color$irm$s\"}' SIZE='10'> Color \n";
print "<INPUT TYPE='text' NAME='norm$irm$s' VALUE='$input{\"norm$irm$s\"}' SIZE='3'> Norm Metric \n";
print "<INPUT TYPE='text' NAME='risk$irm$s' VALUE='$input{\"risk$irm$s\"}' SIZE='5'> Risk \n";
print "<INPUT TYPE='checkbox' NAME='case$irm$s' VALUE='CHECKED' $input{\"case$irm$s\"}> Case Sensitive \n";
print "<BR>\n";
print "<INPUT TYPE='text' NAME='access$irm$s' VALUE='$input{\"access$irm$s\"}' SIZE='60'> Access Object<BR>\n";
}
if ($input{"rptrulesc$i$s"}) {
print "<INPUT TYPE='text' NAME='accessaw$irm$s' VALUE='$input{\"accessaw$irm$s\"}' SIZE='60'> AND With<BR>\n";
print "<INPUT TYPE='text' NAME='accessm1$irm$s' VALUE='$input{\"accessm1$irm$s\"}' SIZE='60'> Previous Object<BR>\n";
print "<INPUT TYPE='text' NAME='accessp1$irm$s' VALUE='$input{\"accessp1$irm$s\"}' SIZE='60'> Next Object<BR>\n";
}
if ($input{"rptrules$i$s"}) {
print "<INPUT TYPE='text' NAME='reject$irm$s' VALUE='$input{\"reject$irm$s\"}' SIZE='60'> Reject Object<BR>\n";
print "<TEXTAREA NAME='comment$irm$s' WRAP=VIRTUAL ROWS='2' COLS='60'>$input{\"comment$irm$s\"}</TEXTAREA> Comment\n";
}
if ($input{"rptrulesc$i$s"}) {
print "<TABLE><TR>\n";
print "<TD><INPUT TYPE='checkbox' NAME='hideobj$irm$s' VALUE='CHECKED' $input{\"hideobj$irm$s\"}><FONT COLOR='$input{\"color$irm$s\"}'>Hide Accessed Objects</FONT></TD>\n";
print "<TD><INPUT TYPE='checkbox' NAME='showchld$irm$s' VALUE='CHECKED' $input{\"showchld$irm$s\"}><FONT COLOR='$input{\"color$irm$s\"}'>Show Child Objects</FONT></TD>\n";
print "<TD><INPUT TYPE='checkbox' NAME='countchld$irm$s' VALUE='CHECKED' $input{\"countchld$irm$s\"}><FONT COLOR='$input{\"color$irm$s\"}'>Count Child Objects</FONT></TD>\n";
print "</TR><TR>\n";
print "<TD><INPUT TYPE='checkbox' NAME='countpat$irm$s' VALUE='CHECKED' $input{\"countpat$irm$s\"}><FONT COLOR='$input{\"color$irm$s\"}'>Count Accessed Patterns</FONT></TD>\n";
print "<TD><INPUT TYPE='checkbox' NAME='countacc$irm$s' VALUE='CHECKED' $input{\"countacc$irm$s\"}><FONT COLOR='$input{\"color$irm$s\"}'>Count Accessed Words</FONT></TD>\n";
print "<TD><INPUT TYPE='checkbox' NAME='countrej$irm$s' VALUE='CHECKED' $input{\"countrej$irm$s\"}><FONT COLOR='$input{\"color$irm$s\"}'>Count Rejected Words</FONT></TD>\n";
print "</TR></TABLE>\n";
}

print "</FONT>\n";
print "<P>\n";

if (!$input{"name$irm$s"}) {last;}
}

}

# hidden rule attributes menu
if ( (!$input{"rptrules$i$s"}) && (!$input{"rptrulesc$i$s"}) ) {
   if ($input{"srvcdescrip$s"}) {print "<INPUT TYPE='hidden' NAME='srvcdescrip$s' VALUE='$input{\"srvcdescrip$s\"}'>\n";}
   if ($input{"srvcname$i"}) {print "<INPUT TYPE='hidden' NAME='srvcname$i' VALUE='$input{\"srvcname$i\"}'>\n";}
   if ($s =~ /rptdup/) {
      if ($input{"mask1$s"}) {print "<INPUT TYPE='hidden' NAME='mask1$s' VALUE='$input{\"mask1$s\"}'>\n";}
      if ($input{"name1$s"}) {print "<INPUT TYPE='hidden' NAME='name1$s' VALUE='$input{\"name1$s\"}'>\n";}
      if ($input{"accessaw$s"}) {print "<INPUT TYPE='hidden' NAME='accessaw$s' VALUE='$input{\"accessaw$s\"}'>\n";}
      next;
   }
}

for ($irm = 1; $irm <= 99; ++$irm) {
if (!$input{"rptrules$i$s"}) {
if ($input{"name$irm$s"}) {print "<INPUT TYPE='hidden' NAME='name$irm$s' VALUE='$input{\"name$irm$s\"}'>\n";}
if ($input{"color$irm$s"}) {print "<INPUT TYPE='hidden' NAME='color$irm$s' VALUE='$input{\"color$irm$s\"}'>\n";}
if ($input{"norm$irm$s"}) {print "<INPUT TYPE='hidden' NAME='norm$irm$s' VALUE='$input{\"norm$irm$s\"}'>\n";}
if ($input{"risk$irm$s"}) {print "<INPUT TYPE='hidden' NAME='risk$irm$s' VALUE='$input{\"risk$irm$s\"}'>\n";}
if ($input{"case$irm$s"}) {print "<INPUT TYPE='hidden' NAME='case$irm$s' VALUE='$input{\"case$irm$s\"}'>\n";}
if ( ($input{"access$irm$s"}) && (!$input{"rptruless$i$s"}) ) {print "<INPUT TYPE='hidden' NAME='access$irm$s' VALUE='$input{\"access$irm$s\"}'>\n";}
}
if (!$input{"rptrulesc$i$s"}) {
if ($input{"accessaw$irm$s"})  {print "<INPUT TYPE='hidden' NAME='accessaw$irm$s' VALUE='$input{\"accessaw$irm$s\"}'>\n";}
if ($input{"accessm1$irm$s"}) {print "<INPUT TYPE='hidden' NAME='accessm1$irm$s' VALUE='$input{\"accessm1$irm$s\"}'>\n";}
if ($input{"accessp1$irm$s"}) {print "<INPUT TYPE='hidden' NAME='accessp1$irm$s' VALUE='$input{\"accessp1$irm$s\"}'>\n";}
}
if (!$input{"rptrules$i$s"}) {
# remove HTML tags but keep linking ability in comment
# - &mdash; " &ldquo; " &rdquo; ' &rsquo; < &lt; > &gt;
$input{"comment$irm$s"} =~ s/'/&rsquo;/g;
if ($input{"reject$irm$s"}) {print "<INPUT TYPE='hidden' NAME='reject$irm$s' VALUE='$input{\"reject$irm$s\"}'>\n";}
if ($input{"comment$irm$s"}) {print "<INPUT TYPE='hidden' NAME='comment$irm$s' VALUE='$input{\"comment$irm$s\"}'>\n";}
}
if (!$input{"rptrulesc$i$s"}) {
if ($input{"hideobj$irm$s"}) {print "<INPUT TYPE='hidden' NAME='hideobj$irm$s' VALUE='$input{\"hideobj$irm$s\"}'>\n";}
if ($input{"showchld$irm$s"}) {print "<INPUT TYPE='hidden' NAME='showchld$irm$s' VALUE='$input{\"showchld$irm$s\"}'>\n";}
if ($input{"countchld$irm$s"}) {print "<INPUT TYPE='hidden' NAME='countchld$irm$s' VALUE='$input{\"countchld$irm$s\"}'>\n";}
if ($input{"countpat$irm$s"}) {print "<INPUT TYPE='hidden' NAME='countpat$irm$s' VALUE='$input{\"countpat$irm$s\"}'>\n";}
if ($input{"countacc$irm$s"}) {print "<INPUT TYPE='hidden' NAME='countacc$irm$s' VALUE='$input{\"countacc$irm$s\"}'>\n";}
if ($input{"countrej$irm$s"}) {print "<INPUT TYPE='hidden' NAME='countrej$irm$s' VALUE='$input{\"countrej$irm$s\"}'>\n";}
}
if (!$input{"name$irm$s"}) {last;}

}

}

####################
sub process {

if ($keydate =~ /demo/i) {

   if ($url =~ /sat/) {$lui = "../../Program Files/clpsbt.dat";}
   if ($url =~ /gda/) {$lui = "../../Program Files/clpgdb.dat";}
   if ($url =~ /cla/) {$lui = "../../Program Files/clpclb.dat";}
   if ($url =~ /lat/) {$lui = "../../Program Files/clplbt.dat";}
   if ($url =~ /lda/) {$lui = "../../Program Files/clpldb.dat";}
   if ($url =~ /cat/) {$lui = "../../Program Files/clpcbt.dat";}
   if ($url =~ /pla/) {$lui = "../../Program Files/clpplb.dat";}
   if ($url =~ /dev/) {$lui = "../../Program Files/clpdfv.dat";}
   if ($url =~ /mta/) {$lui = "../../Program Files/clpmtb.dat";}
   if ($url =~ /dva/) {$lui = "../../Program Files/clpdvb.dat";}

   if ( open(CLP,"$lui") ) {
      $clp = <CLP>;
      close(CLP);
   }
   else {
      $clp = 500;
   }

   print "<CENTER><FONT COLOR='RED'><H2>This is a demo. ";
   print "There are humans here that need to eat and play. ";
   print "Please consider buying $toolname <A HREF='http://www.cassbeth.com'>www.cassbeth.com</A> </H2>";
   print "If you have your new upgrade keys <A HREF=$script?upgrade=y'>Start Upgrade</A></FONT> $clp<P></CENTER>\n";

   $clp++;
   open(CLP,">$lui");
   print CLP "$clp";
   close(CLP);
   print "<HR>";

   $maxrun = int(rand(10) + 90);

   if ($clp > $maxrun) {
      print "<CENTER><FONT COLOR='RED'><H2>This was your last analysis. ";
      print "For future work you must now purchase our tool. ";
      print "Contact us if you are unable to purchase the tool for whatever reason. ";
      print "We will consider your situation and try to work with you. ";
      print "Thank you for using our tool.</H2></FONT><P></CENTER>\n";
      exec("exp.cgi");
   }
}

print "<A NAME='analysisresults'> </A><BIG><BIG><B>Analysis Results</B></BIG></BIG> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hidear' VALUE='CHECKED' $input{'hidear'}> Hide</SMALL>";
print "<P>";

# display filters
if (!$input{'hidear'}) {
print "
<B>Filter</B> case sensitive
<BR>
<INPUT TYPE='text' NAME='fraccess' VALUE='$input{\"fraccess\"}' SIZE='20'> <A HREF='help.html#Access Object' TARGET='HELP'>Access Object</A> 
<INPUT TYPE='text' NAME='frreject' VALUE='$input{\"frreject\"}' SIZE='20'> <A HREF='help.html#Reject Object' TARGET='HELP'>Reject Object</A> 
<INPUT TYPE='text' NAME='frrisk' VALUE='$input{\"frrisk\"}' SIZE='8'> <A HREF='help.html#Access Risk' TARGET='HELP'>Access Risk</A><BR>
<BR>
<INPUT TYPE='checkbox' NAME='showocmts' VALUE='CHECKED' $input{'showocmts'}> <A HREF='help.html#Show Object Comments' TARGET='HELP'>Show Comment Details</A> 
<INPUT TYPE='checkbox' NAME='hideocmts' VALUE='CHECKED' $input{'hideocmts'}> <A HREF='help.html#Hide Object Comments' TARGET='HELP'>Hide All Comments</A> 
<INPUT TYPE='checkbox' NAME='hidechkdi' VALUE='CHECKED' $input{'hidechkdi'}> <A HREF='help.html#Hide Checked Items' TARGET='HELP'>Hide Checked Items</A> 
<INPUT TYPE='checkbox' NAME='srdbsave' VALUE='CHECKED' $input{'srdbsave'}> <A HREF='help.html#Save Results' TARGET='HELP'>Save Results</A> . 
<A HREF='previous-analysis/srdb.xls' TARGET='metrics'>File</A>
<P>";
}

#if ( ($ENV{'HTTP_REFERER'} !~ /\.cgi|\.pl|sat|cat|cla|gda|lat|pla|atc|mta/) || ($input{'restart'}) ) {
if ( ($ENV{'HTTP_REFERER'} !~ /\.cgi|\.pl/) || ($input{'restart'}) ) {
   $file = "temp/spec.doc";
   $status = unlink $file;
   print "Removed old doc file: $status ";

   $file = "temp/spec.tmp";
   $status = unlink $file;
   print "Removed old tmp file: $status ";

   $file = "temp/spec.html";
   $status = unlink $file;
   print "Removed old html file: $status ";
   ##return;
}

# parse .doc file
if ($incfn{'upfile'} =~ /\.doc$/) {
   print "You have uploaded a .doc file. ";
   print "$toolname will try to work with it, but you may lose data and the parse may be not what you intended. ";
   print "Suggest saving your .doc file as .txt and remove the noise text from the document such as the table of contents.<P>";

   $file = "temp/spec.doc";
   open(FILE, ">$file") || &CgiDie("Couldn't open $file\n");
   binmode (FILE);  # write files accurately
   print FILE "$input{'upfile'}";
   close(FILE);

   $ex = "";
   if ($input{'ptole'}) {
      use Win32::OLE;
      use Win32::OLE::Enum;
      $ex = Win32::OLE->new('Word.Application', 'Quit');
   }
   if ($ex) {
      $strip .= "Extracting Text using Word OLE services $ex<BR>\n";
      $docfile = "temp/spec.doc";
      $document = Win32::OLE ->GetObject($docfile) or $badole = 1;
      #$document = Win32::OLE ->GetObject($docfile) || die Win32::OLE-> LastError();
      if ($badole) {
         $strip .= "Sorry but we were unable to make an OLE connection to Word.<BR>";
         $strip .= "Uncheck the OLE option in the Parse service and rerun your file upload.<P>";
         $ex = "";
      }
      else {
         $strip .= "Made an OLE connection to Word.<P>";
         $input{'upfile'} = "";
         $paragraphs = $document->Paragraphs();
         $enumerate = new Win32::OLE::Enum($paragraphs);
         while(defined($paragraph = $enumerate->Next())) {
             #$style = $paragraph->{Style}->{NameLocal};
             #$input{'upfile'} .= "$style ";
             $text = $paragraph->{Range}->{Text};
             $text =~ s/[\n\r]//g;
             $text =~ s/\x0b/\n/g;
             $input{'upfile'} .= "$text\n";
         }
      }
   }
   if (!$ex) {
      $strip .= "Did not use Word on your computer to convert this file. ";
      $strip .= "I will do my best to convert this to readable format.<BR>";

      $input{'upfile'} =~ s/(\w\w\.\s+)(\w)/$1\n$2/g;
      $input{'upfile'} =~ s/\r/\n/g; 
      $input{'upfile'} =~ s/\n+/\n/g; 
      $input{'upfile'} =~ s/\x07/ /g; 
      #$input{'upfile'} =~ s/\x00//g; 
      #$input{'upfile'} =~ s/\xFF//g; 
      $input{'upfile'} =~ s/[^a-zA-Z0-9\n\t\r_\{\}\(\)\<\>\.-=+\?\\\/,\;:'\"\!\~\@\#\$\%\^\&\*\| ]//g;
      $input{'upfile'} =~ s/ +/ /g;
      #$input{'upfile'} =~ s/[^\s]{1,2}?\s[^\s]{1,2}?\s[^\s]{1,2}?\s[^\s]{1,2}?\s/ /g;
      #$input{'upfile'} =~ s/ +/ /g;

      #$H = "\211PNG";
      #$F = "IEND\xAEB`\x82";
      #$input{'upfile'} =~ s/$H.*?$F/IMAGE/sg;

      #@items = split(/\n/,$input{'upfile'});
      #$input{'upfile'} = "";
      #foreach $item (@items) {
      #   if ($item !~ / /) {next;}
      #   $input{'upfile'} .= "$item\n";
      #}
   }

}

# parse .csv file
if ($incfn{'upfile'} =~ /\.csv$/) {
   print "You have uploaded a .csv file. ";
   print "If there are multiple items per attribute $toolname will try to process up to 10 items as a single line entry. ";
   print "These items will be seperated by a - dash.<P>";
   # 10 settings per attribute
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/(,\"[^\"]+)\n/$1-/g;
   $input{'upfile'} =~ s/\n\s+/\n/g;
}

# parse .txt file
if ($incfn{'upfile'} =~ /\.txt$/) {
   print "You have uploaded a .txt file. ";
   print "There should be one complete sentence per line in the text file. ";
   print "If your sentences have multiple forced line breaks select, select the parse text option and upload the file again. ";
   print "Alternatively clean up your text file using an editor by removing spaces and extra line breaks.<P>";
}

# save up loaded file
if ($incfn{'upfile'}) {
   $file = "temp/spec.tmp";
   open(FILE, ">$file") || &CgiDie("Couldn't open $file\n");
   binmode (FILE);  # write files accurately
   # strip html file
   if ($input{'striphtml'}) {
      $strip .= "Stripped HTML Tags in uploaded FILE";
      print "$strip<P>\n";
      $input{'upfile'} =~ s/\s+/ /g;
      $input{'upfile'} =~ s/<BR>|<P[^>]*>|<LI>|<\/[^>]+>/\n/ig;
      $input{'upfile'} =~ s/<[^<]+>//g;
      $input{'upfile'} =~ s/\s+\n/\n/g;
      $input{'upfile'} =~ s/\n\s+/\n/g;
      $input{'upfile'} =~ s/\n+/\n/g;
   }
   # parse text
   if ($input{'parsetxt'}) {

      # chop and reject
      print "<BR>";
      if ($input{'ptaccess'}) {$strip .= "Access only lines using pattern: <I>$input{'ptaccess'}</I>.<BR>";}
      if ($input{'ptreject'}) {$strip .= "Rejected lines using pattern: <I>$input{'ptreject'}</I>.<BR>";}
      if ($input{'ptstart'}) {$strip .= "Chopped top of document up to Start: <I>$input{'ptstart'}</I>.<BR>";}
      if ($input{'ptend'}) {$strip .= "Chopped bottom of document up to End: <I>$input{'ptend'}</I>.<BR>";}
      @items = split(/\n/,$input{'upfile'});
      $input{'upfile'} = "";
      $found = "";
      foreach $item (@items) {
         if ( ($input{'ptstart'}) && ($item =~ /$input{'ptstart'}/) ) {$found = 1;}
         if ( ($input{'ptstart'}) && (!$found) ) {next;}
         if ( ($input{'ptreject'}) && ($item =~ /$input{'ptreject'}/) ) {next;}
         $input{'upfile'} .= "$item\n";
         #if ( ($input{'ptend'}) && ($item =~ /$input{'ptend'}/) ) {last;}
      }
      # parse into complete thought
      $strip .= "Parsed the text in uploaded FILE into complete thoughts using the period punctuation. Stripped extra spaces and line feeds.";
      print "$strip<P>\n";
      $input{'upfile'} =~ s/\s+/ /g; 
      #$input{'upfile'} =~ s/(\w\w\.\s+)(\w|\(|\[|\{)/$1\n$2/g;
      #$input{'upfile'} =~ s/(..\.\s+)(\w|\(|\[|\{)/$1\n$2/g;
      $input{'upfile'} =~ s/(..\.\s+)(.)/$1\n$2/g;
      $input{'upfile'} =~ s/\r/\n/g; 
      $input{'upfile'} =~ s/\n+/\n/g;
      # access only
      @items = split(/\n/,$input{'upfile'});
      $input{'upfile'} = "";
      foreach $item (@items) {
         if ( ($input{'ptaccess'}) && ($item !~ /$input{'ptaccess'}/) ) {next;}
         $input{'upfile'} .= "$item\n";
         if ( ($input{'ptend'}) && ($item =~ /$input{'ptend'}/) ) {last;}
      }

   }
   # strip blank lines file
   if ($input{'stripblkl'}) {
      $strip .= "Stripped Blank Lines in uploaded FILE";
      print "$strip<P>\n";
      $input{'upfile'} =~ s/\n\s*\n/\n/g;
   }
   # save processed file
   print FILE "$input{'upfile'}";
   close(FILE);
   print "<INPUT TYPE='hidden' NAME='file' VALUE='$incfn{'upfile'}'>\n";

   @html = split(/\n/,$input{'upfile'});
   $hfile = "temp/spec.html";
   open(HFILE, ">$hfile") || &CgiDie("Couldn't open $file\n");
   binmode (HFILE);  # write files accurately
   print HFILE "<B>NOTE: The Strip Blank Lines or Parse Text or Strip HTML Tags selections must be synchronized with the file upload state or ";
   print HFILE "these PUIs and links will not match the PUIs and links in the analysis report. If you think you are in sync and this report ";
   print HFILE "does not match your expectation hit the browser reload button.</B><P>$strip<P>\n";
   for ($ihf = 0; $ihf <= $#html; ++$ihf) {
      $sat_obj = $html[$ihf];
      $sat_obj =~ s/($input{'puimask'})(.*)/$1$2/;
      $sat_pui = $1;
      $sat_txt = $2;
      if (!$sat_pui) {$sat_pui = "$tui-$ihf"; $sat_txt = $sat_obj;}
      print HFILE "<A HREF='#$ihf'><SMALL>$sat_pui</SMALL></A><A NAME='$ihf'> . </A>$sat_txt<P>\n";
   }
   close(HFILE);
}

if ($input{'upgrade'}) {
   $demo = "<B><BIG>We are now ready for Upgrade >> from demo <A HREF='$script'>Upgrade Now</A></BIG></B>";
   print "$demo<P>";
   unlink "pck.txt";
   exit;
}

# if no uploaded file check if file exists and load it
if ( (!$incfn{'upfile'}) && ($ENV{'HTTP_REFERER'} =~ /\.cgi|\.pl/) ) {
   $file = "temp/spec.tmp";
   open(FILE, "$file") or $filestatus = "Please Upload a File";
   binmode (FILE);  # write files accurately
   if ($filestatus =~ /Please Upload a File/) {
      print "$filestatus<P>";
      print "<INPUT TYPE='hidden' NAME='file' VALUE='Please Upload a File'>\n";
      return;
   }
   #$filestatus = "z-cassbeth/sat/temp/spec.tmp";
   $filestatus = "temp/spec.tmp";
   if ($input{'file'}) {$filestatus = $input{'file'};}
   print "<INPUT TYPE='hidden' NAME='file' VALUE='$filestatus'>\n";
   print "<B><FONT COLOR='RED'>Processing previously uploaded file in</FONT></B> <A HREF='$file' TARGET='FILE'>$filestatus</A><P>";
   while (<FILE>) {
      $input{'upfile'} .= $_;
   }
   close(FILE);

   # strip html live
   if ($input{'striphtml'}) {
      print "Stripped HTML Tags during analysis. You may need to upload the file again to match the PUIs.<P>\n";
      if ($input{'upfile'} =~ /<BR>|<P>|<LI>|<\//i) {
         $input{'upfile'} =~ s/\s+/ /g;
         $input{'upfile'} =~ s/<BR>|<P[^>]*>|<LI>|<\/[^>]+>/\n/ig;
         $input{'upfile'} =~ s/<[^<]+>//g;
         $input{'upfile'} =~ s/\s+\n/\n/g;
         $input{'upfile'} =~ s/\n\s+/\n/g;
         $input{'upfile'} =~ s/\n+/\n/g;
      }
   }
   # parse text live
   if ($input{'parsetxt'}) {
      print "Parsed the text during analysis. You may need to upload the file again to match the PUIs.<P>\n";

      # chop and reject
      print "<BR>";
      if ($input{'ptaccess'}) {$strip .= "Access only lines using pattern: <I>$input{'ptaccess'}</I>.<BR>";}
      if ($input{'ptreject'}) {$strip .= "Rejected lines using pattern: <I>$input{'ptreject'}</I>.<BR>";}
      if ($input{'ptstart'}) {$strip .= "Chopped top of document up to Start: <I>$input{'ptstart'}</I>.<BR>";}
      if ($input{'ptend'}) {$strip .= "Chopped bottom of document up to End: <I>$input{'ptend'}</I>.<BR>";}
      @items = split(/\n/,$input{'upfile'});
      $input{'upfile'} = "";
      $found = "";
      foreach $item (@items) {
         if ( ($input{'ptstart'}) && ($item =~ /$input{'ptstart'}/) ) {$found = 1;}
         if ( ($input{'ptstart'}) && (!$found) ) {next;}
         if ( ($input{'ptreject'}) && ($item =~ /$input{'ptreject'}/) ) {next;}
         $input{'upfile'} .= "$item\n";
         #if ( ($input{'ptend'}) && ($item =~ /$input{'ptend'}/) ) {last;}
      }
      # parse into complete thought
      $strip .= "Parsed the text in uploaded FILE into complete thoughts using the period punctuation. Stripped extra spaces and line feeds.";
      print "$strip<P>\n";
      $input{'upfile'} =~ s/\s+/ /g; 
      #$input{'upfile'} =~ s/(\w\w\.\s+)(\w|\(|\[|\{)/$1\n$2/g;
      #$input{'upfile'} =~ s/(..\.\s+)(\w|\(|\[|\{)/$1\n$2/g;
      $input{'upfile'} =~ s/(..\.\s+)(.)/$1\n$2/g;
      $input{'upfile'} =~ s/\r/\n/g; 
      $input{'upfile'} =~ s/\n+/\n/g;
      # access only
      @items = split(/\n/,$input{'upfile'});
      $input{'upfile'} = "";
      foreach $item (@items) {
         if ( ($input{'ptaccess'}) && ($item !~ /$input{'ptaccess'}/) ) {next;}
         #$item =~ s/(.*)($input{'ptaccess'})(.*)/$1<B>$2<\/B>$3/;
         $input{'upfile'} .= "$item\n";
         if ( ($input{'ptend'}) && ($item =~ /$input{'ptend'}/) ) {last;}
      }
   }
}

# Show uploaded file
if ($input{'showupld_out'}) {
   ($text = $input{'upfile'}) =~ s/\n/\n<BR>/g; 
   print "<P>$text<P>";
   return;
}

@items = split(/\n/,$input{'upfile'});

if ($input{'search'}) {
   print "<H2>Search</H2>";
   #$input{'search'} =~ s/^\s+//;
   #$input{'search'} =~ s/\s+$//;
   #$input{'search'} =~ s/\W+/|/g;
   $input{'search'} =~ s/\x00/|/g;
   $input{'search'} =~ s/^\|+//;
   $input{'search'} =~ s/\|+$//;
   print "-$input{'search'}-<P>";
}

if($input{'srdbsave'}) {
   close(SRDB);
   open(SRDB,">previous-analysis/srdb.xls") || print "<FONT COLOR='RED'>Unable to save SRDB, close anything viewing the file.</FONT><P>";
   print SRDB "Absolute Number\tObject Text\t$tui Findings\n";
}

for ($r = 0; $r <= $#items; ++$r) {

   if ( ($input{'rptshalls'}) && ($items[$r] !~ /$input{'imperatives'}/i) ) {next;}
   #if ($input{'striphtml'}) {$items[$r] =~ s/<[^<]+>//g;}

   if ( ($input{'fraccess'}) && ($items[$r] !~ /$input{'fraccess'}/) ) {next;}
   if ( ($input{'frreject'}) && ($items[$r] =~ /$input{'frreject'}/) ) {next;}

   if ( ($input{'fraccess'}) && ($items[$r] =~ /$input{'fraccess'}/) ) {
      $items[$r] =~ s/(.*)($input{'fraccess'})(.*)/$1<B>$2<\/B>$3/; 
   }

   $count_all++;
   if ($items[$r] !~ /\w/) {$count_blk++; next;}
   $count_nb++;

   $sat_obj = $items[$r];
   $sat_obj =~ s/($input{'puimask'})(.*)/$1$2/;
   $sat_pui = $1;
   $sat_txt = $2;
   if (!$sat_pui) {$sat_pui = "$tui-$r"; $sat_txt = $sat_obj;}
   $sat_mat = $sat_txt;
   if ($input{'mask1rptdup'}) {$sat_mat =~ s/$input{'mask1rptdup'}//ig;}
   $sat_mat =~ s/\W/ /g;
   $sat_mat =~ s/\s+/ /g;

   if ($sat_obj =~ /$input{'imperatives'}/i) {$imperative++;}
   if ($sat_obj =~ /shall/i) {$shall++;}
   if ($sat_obj =~ /\bwill\b/i) {$will++;}
   if ($sat_obj =~ /IsReq/) {$isreq++;}

   $cmt = "";

   # bypass if checked
   if ( ($input{'hidechkdi'}) && ($input{$sat_pui} =~ /CHECKED/) ) {
      #if ($keydate =~ /demo/i) {$count++;}
      if ($input{$sat_pui}) {print "<INPUT TYPE='hidden' NAME='$sat_pui' VALUE='$input{$sat_pui}'>\n";}
      next;
   }

   &mine_object;
}

print "Processed Entire File<HR>";

}

####################
sub find_duplicates{

   # find duplicates

      $dup = 0;
      for ($rd = $r+1; $rd <= $#items; ++$rd) {
         $dup_obj = $items[$rd];
         $dup_obj =~ s/($input{'puimask'})(.*)/$1$2/;
         $dup_pui = $1;
         $dup_txt = $2;
         if (!$dup_pui) {$dup_pui = "$tui-$rd"; $dup_txt = $dup_obj;}
         $dup_pui_1 = "<A HREF='temp/spec.html#$rd' TARGET='SH'>$dup_pui</A>";
         $dup_mat = $dup_txt;
         if ($input{'mask1rptdup'}) {$dup_mat =~ s/$input{'mask1rptdup'}//ig;}
         $dup_mat =~ s/\W/ /g;
         $dup_mat =~ s/\s+/ /g;
         #print "$dup_mat<BR>";
         if ( ($dup_mat =~ /$sat_mat/) && ($rd == $r+1) ) {
            $cmt .= "<BR><SMALL> . . . <FONT COLOR='RED'><B>Consecutive Duplicate:</B></FONT> $dup_pui_1 $dup_txt</SMALL>\n";
            if ($input{'hideocmts'}) {$cmt = ".";}
            $metric{'Duplicate Consecutive'}++;
         }
         if ( ($dup_mat eq $sat_mat) && ($dup_mat =~ /$input{'imperatives'}/i) ) {
            $cmt .= "<SMALL><BR> . . . <FONT COLOR='RED'><B>Duplicate Imperative:</B></FONT> $dup_pui_1 $dup_txt\n";
            $cmt .= "<BR> . . . . . . REQ: $sat_mat";
            $cmt .= "<BR> . . . . . . DUP: $dup_mat</SMALL>";
            if ($input{'hideocmts'}) {$cmt = ".";}
            $metric{"$input{'name1rptdup'} <FONT COLOR=''>rptdup</FONT>"}++;
            $metric{'Duplicate Imperative'}++;
         }
         elsif ($dup_mat eq $sat_mat) {
            $cmt .= "<SMALL><BR> . . . <FONT COLOR='RED'><B>Duplicate Text:</B></FONT> $dup_pui_1 $dup_txt\n";
            $cmt .= "<BR> . . . . . . REQ: $sat_mat";
            $cmt .= "<BR> . . . . . . DUP: $dup_mat</SMALL>";
            if ($input{'hideocmts'}) {$cmt = ".";}
            $metric{"$input{'name1rptdup'} <FONT COLOR=''>rptdup</FONT>"}++;
            $metric{'Duplicate Text'}++;
         }
      }

}

####################
sub mine_object {

local($s) = @_;

for ($is = 1; $is <= 20; ++$is) {

   if (!$input{"srvcname$is"}) {

      # show mined objects
      if ( ($cmt) && (!$input{'hidear'}) ) {
         $count++;
         if (!$metric{'z Mined Objects'}) {$metric{'z Mined Objects'}++};
         $metric{'z Mined Objects'}++;
         if (!$input{'search'}) {
            print "<INPUT TYPE='checkbox' NAME='$sat_pui' VALUE='CHECKED' $input{$sat_pui}> ";
            print "<B>$count.</B> <A HREF='temp/spec.html#$r' TARGET='SH'>$sat_pui</A> $sat_txt ";
            print "$cmt<P>\n";
         }
         if ( ($input{'search'}) && ($sat_txt =~ /$input{'search'}/i) ) {
            $sat_txt =~ s/($input{'search'})/<B>$1<\/B>/ig;
            print "<B>$count.</B> <A HREF='temp/spec.html#$r' TARGET='SH'>$sat_pui</A> $sat_txt ";
            print "$cmt<P>\n";
         }
         if($input{'srdbsave'}) {
            select(SRDB);
            $sat_pui =~ s/[^0-9]//g;
            $sat_txt =~ s/<[^>]+>//g;
            $sat_txt =~ s/\s+/ /g;
            $cmt =~ s/<[^>]+>//g;
            $cmt =~ s/\s+/ /g;
            $cmt =~ s/^ . . . //g;
            print "$sat_pui\t";
            print "$sat_txt\t";
            print "$cmt\n";
            select(STDOUT);
         }
      }

      # show all objects
      if ( (!$cmt) && ($input{'showupld'}) && (!$input{'hidear'}) ) {
         if ($sat_puiold ne $sat_pui) {
            $count++;
            print "<INPUT TYPE='checkbox' NAME='$sat_pui' VALUE='CHECKED' $input{$sat_pui}> ";
            print "<B>$count.</B> <A HREF='temp/spec.html#$r' TARGET='SH'>$sat_pui</A> $sat_txt<P>";
         }
      }
      $sat_puiold = $sat_pui;
      $cmt = "";

      # show children
      if($chldrn{"$s"} > 1) {
         if ($countchld_1) {$metric_child{$chldrule}++;}
         if ($showchld_1) {
            print " . . . <B>$metric_child{$chldrule}.</B> $sat_pui $sat_txt";
            print " . <SMALL>CHILD $input{\"srvcname$is\"}</SMALL><P>";
         }
      }
      if ($chldrn{"$s"}) {$chldrn{"$s"}++;}
      last;
   }

   #if ($input{"rptrules$is"} !~ /CHECKED/i) {next;}
   if ($input{"srvc$is"} !~ /CHECKED/i) {next;}

   if ( ($input{'srvc2'}) && ($input{'rpt1rptdup'}) ) {&find_duplicates;}

   $s = $input{"srvcpui$is"};
   $s =~ s/rta//;
   #if ($s =~ /rptdup/i) {next;}
   #$cmt = "";

   for ($i = 1; $i <= 99; ++$i) {
      if (!$input{"name$i$s"}) {last;}

      # if indented then not fully implemented
      $name    = "name$i$s";
      $color   = "color$i$s";
      $norm    = "norm$i$s";
      $risk    = "risk$i$s";
      $case    = "case$i$s";
      $access  = "access$i$s";
      $accessaw  = "accessaw$i$s";
      $accessm1  = "accessm1$i$s";
      $accessp1  = "accessp1$i$s";
      $reject  = "reject$i$s";
      $rpt     = "rpt$i$s";
      $comment = "comment$i$s";

      $hideobj   = "hideobj$i$s";
      $showchld  = "showchld$i$s";
      $countchld = "countchld$i$s";

      $countpat  = "countpat$i$s";
      $countacc  = "countacc$i$s";
      $countrej  = "countrej$i$s";

      $hidecount   = "hidecount$i$s";
      $hideletters = "hideletters$i$s";
      $noise       = "noise$i$s";
      $noiseusr    = "noiseusr$i$s";

      # access risk levels
      if ($input{'frrisk'}) {
         if ($input{$risk} !~ /$input{'frrisk'}/) {next;}
      }

      # AND access object case sensative
      if ( ($input{$case}) && ($input{$accessaw}) ) {
         if ($sat_txt !~ /$input{$accessaw}/) {next;}
         $sat_txt =~ s/($input{$accessaw})/<FONT COLOR='$input{$color}'><B>$1<\/B><\/FONT>/g;
      }

      # AND access object case insensative
      if ( (!$input{$case}) && ($input{$accessaw}) ) {
         if ($sat_txt !~ /$input{$accessaw}/i) {next;}
         $sat_txt =~ s/($input{$accessaw})/<FONT COLOR='$input{$color}'><B>$1<\/B><\/FONT>/ig;
      }

      # find accessed patterns
      if ( ($input{$countpat}) && ($input{$access}) && ($input{$case}) ) {
         @words = split(/\|/,$input{$access});
         foreach $word (@words) {
            if ($sat_txt =~ /($word)/) {$accessedpatterns{"<FONT COLOR='$input{$color}'>$1</FONT>"}++;}
         }
      }
      if ( ($input{$countpat}) && ($input{$access}) && (!$input{$case}) ) {
         @words = split(/\|/,$input{$access});
         foreach $word (@words) {
            if ($sat_txt =~ /($word)/i) {$accessedpatterns{"<FONT COLOR='$input{$color}'>$1</FONT>"}++;}
         }
      }

      # find rejects
      if ( ($input{$reject}) && ($input{$case}) && ($sat_obj =~ /$input{$reject}/) ) {
         if ($input{$countrej}) {
            @words = split(/\s+/,$sat_obj);
            foreach $word (@words) {
               $word =~ s/[^a-zA-Z0-9_\-\=]//g;
               $word =~ s/(.*)/\L$1/ig;
               $accessedwords{"<FONT COLOR='$input{$color}'>$word</FONT>"}++;
            }
         }
         next;
      }
      if ( ($input{$reject}) && (!$input{$case}) && ($sat_obj =~ /$input{$reject}/i) ) {
         if ($input{$countrej}) {
            @words = split(/\s+/,$sat_obj);
            foreach $word (@words) {
               $word =~ s/[^a-zA-Z0-9_\-\=]//g;
               $word =~ s/(.*)/\L$1/ig;
               $accessedwords{"<FONT COLOR='$input{$color}'>$word</FONT>"}++;
            }
         }
         next;
      }

      # accessp1 and accessm1 processing
      $dontshow = "";
      if ($input{$rpt}) {
      if ($input{$accessp1}) {
         $dontshow = 1;
         $sat_objp1 = $items[$r+1];
         $sat_objp1 =~ s/($input{'puimask'})(.*)/$1$2/;
         $sat_puip1 = $1;
         $sat_txtp1 = $2;
         if (!$sat_puip1) {$sat_puip1 = "$tui-$r"; $sat_txtp1 = $sat_objp1;}
         if ( (!$input{$case}) && ($sat_txtp1 =~ /$input{$accessp1}/i) ) {$dontshow = 0;}
         if ( ($input{$case}) && ($sat_txtp1 =~ /$input{$accessp1}/) ) {$dontshow = 0;}
      }
      if ($input{$accessm1}) {
         $dontshow = 1;
         $sat_objm1 = $items[$r-1];
         $sat_objm1 =~ s/($input{'puimask'})(.*)/$1$2/;
         $sat_puim1 = $1;
         $sat_txtm1 = $2;
         if (!$sat_puim1) {$sat_puim1 = "$tui-$r"; $sat_txtm1 = $sat_objm1;}
         if ( (!$input{$case}) && ($sat_txtm1 =~ /$input{$accessm1}/i) ) {$dontshow = 0;}
         if ( ($input{$case}) && ($sat_txtm1 =~ /$input{$accessm1}/) ) {$dontshow = 0;}
      }
      }

      # mine case sensative
      if ( ($input{$case}) && ($input{$rpt}) && ($input{$access}) && (!$dontshow) && ($sat_txt =~ /($input{$access})/) ) {
         $wewe = $1;
         if ($input{$countacc}) {
            @words = split(/\s+/,$sat_obj);
            foreach $word (@words) {
               #$word =~ s/\W//g;
               $word =~ s/[^a-zA-Z0-9_\-\=]//g;
               $word =~ s/(.*)/\L$1/ig;
               $accessedwords{"<FONT COLOR='$input{$color}'>$word</FONT>"}++;
            }
         }
         # metrics
         #$metric{"$input{$name} <FONT COLOR='$input{$color}'>$s</FONT>"}++;
         $metric{"$input{$name} <FONT COLOR='$input{$color}'>$input{\"srvcpui$is\"}</FONT>"}++;
         if ( (!$input{$hideobj}) || ($input{'search'}) ) {
            $blah = $sat_txt =~ s/($input{$access})/<FONT COLOR='$input{$color}'><B>$1<\/B><\/FONT>/g;
            if ($input{'showocmts'}) {
               $cmt .= "<SMALL><BR> . . . <INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'> <FONT COLOR='$input{$color}'><B>$input{$name}:</B> $input{\"srvcname$is\"}</FONT> Risk: <B>$input{$risk}</B> Item: <B>$wewe</B> Instance: $blah Comment: $input{$comment}</SMALL>\n";
               if ($input{'hideocmts'}) {$cmt = ".";}
            }
            if (!$input{'showocmts'}) {
               $cmt .= "<SMALL><BR> . . . <INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'> <A HREF='#$input{$name}'><FONT COLOR='$input{$color}'><B>$input{$name}</B></FONT></A> $input{\"srvcname$is\"} Risk: <B>$input{$risk}</B> Item: <B>$wewe</B> Instance: $blah</SMALL>\n";
               if ($input{'hideocmts'}) {$cmt = ".";}
            }
         }
         # child processing
         $chldrn{$s} = 0;
         $dispchld = "";
         $chldrule = "";
         if ( ($input{$showchld}) || ($input{$countchld}) ) {
            $chldrn{$s} = 1;
            $chldrule = "$input{$name} <FONT COLOR='$input{$color}'>$s</FONT>";
            $showchld_1 = $input{$showchld};
            $countchld_1 = $input{$countchld};
         }
      }

      # mine case insensative
      if ( (!$input{$case}) && ($input{$rpt}) && ($input{$access}) && (!$dontshow) && ($sat_txt =~ /($input{$access})/i) ) {
         $wewe = $1;
         # count keywords
         if ($input{$countacc}) {
            @words = split(/\s+/,$sat_obj);
            foreach $word (@words) {
               #$word =~ s/\W//g;
               $word =~ s/[^a-zA-Z0-9_\-\=]//g;
               $word =~ s/(.*)/\L$1/ig;
               $accessedwords{"<FONT COLOR='$input{$color}'>$word</FONT>"}++;
            }
         }
         # metrics
         #$metric{"$input{$name} <FONT COLOR='$input{$color}'>$s</FONT>"}++;
         $metric{"$input{$name} <FONT COLOR='$input{$color}'>$input{\"srvcpui$is\"}</FONT>"}++;
         # show object
         if ( (!$input{$hideobj}) || ($input{'search'}) ) {
            $blah = $sat_txt =~ s/($input{$access})/<FONT COLOR='$input{$color}'><B>$1<\/B><\/FONT>/ig;
            if ($input{'showocmts'}) {
               $cmt .= "<SMALL><BR> . . . <INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'> <FONT COLOR='$input{$color}'><B>$input{$name}:</B> $input{\"srvcname$is\"}</FONT> Risk: <B>$input{$risk}</B> Item: <B>$wewe</B> Instance: $blah Comment: $input{$comment}</SMALL>\n";
               if ($input{'hideocmts'}) {$cmt = ".";}
            }
            if (!$input{'showocmts'}) {
               $cmt .= "<SMALL><BR> . . . <INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'> <A HREF='#$input{$name}'><FONT COLOR='$input{$color}'><B>$input{$name}</B></FONT></A> $input{\"srvcname$is\"} Risk: <B>$input{$risk}</B> Item: <B>$wewe</B> Instance: $blah</SMALL>\n";
               if ($input{'hideocmts'}) {$cmt = ".";}
            }
         }
         # child processing
         $chldrn{$s} = 0;
         $dispchld = "";
         $chldrule = "";
         if ( ($input{$showchld}) || ($input{$countchld}) ) {
            $chldrn{$s} = 1;
            $chldrule = "$input{$name} <FONT COLOR='$input{$color}'>$s</FONT>";
            $showchld_1 = $input{$showchld};
            $countchld_1 = $input{$countchld};
         }
      }
   }
   # show results

}

}

####################
sub accessed_words {

print "<A NAME='accessedwords'> </A><BIG><BIG><B>Accessed Words</B></BIG></BIG> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hideaw' VALUE='CHECKED' $input{'hideaw'}> Hide</SMALL>\n";
print "<P>\n";

# display filters
print "<INPUT TYPE='checkbox' NAME='fxdnoise' VALUE='CHECKED' $input{'fxdnoise'}> <A HREF='help.html#Filter Noise Words' TARGET='HELP'>Filter Noise Words</A><P>\n";

# noise control patterns
if ($input{'fxdnoise'}) {
   $fltrnoise = $d_noise;
   if ($input{'usrnoise'}) {$fltrnoise = $input{'usrnoise'};}
   print "<B>Noise Patterns:</B> update these patterns as needed<BR>";
   print "<TEXTAREA NAME='usrnoise' WRAP=VIRTUAL ROWS='5' COLS='60'>$fltrnoise</TEXTAREA><P>\n";
} 

if ($input{'hideaw'}) {
   foreach $word (sort flipaccessedwords keys(%accessedwords)) {
     $wewe = $word;
     $wewe =~ s/<[^<]+>//g;
     $wewe_1 = $word;
     $wewe_1 =~ s/<[^<]+>/ /g;
     if ( ($input{'fxdnoise'}) && ($wewe_1 =~ /$fltrnoise/i) ) {next;}
     $uwrds ++;
     $syllables = $wewe_1 =~ s/([^aeiou][aeiou])/$1/ig;
     if ($wewe_1 =~ /e\s*$/i) {$syllables--;}
     if ($wewe_1 =~ /y\s*$/i) {$syllables++;}
     if ($syllables >= 3) {$sylblwrds++;}
     $syllablestot += $syllables;
     if ($column == 0) {print "<TR>";}
   }
   return;
}

if (!%accessedwords) {print "No results to report.\n"; return;}

print "<P><B><BIG>Number Sort</BIG></B>\n";
#print "<INPUT TYPE='radio' NAME='search' VALUE='' CHECKED> Search None<P>\n";
print "<TABLE>";
$column = 0;
$uwrds = 0;
foreach $word (sort flipaccessedwords keys(%accessedwords)) {
  $wewe = $word;
  $wewe =~ s/<[^<]+>//g;
  #$wewe =~ s/\s+$//;
  #$wewe =~ s/^\s+//;
  $wewe_1 = $word;
  $wewe_1 =~ s/<[^<]+>/ /g;
  if ( ($input{'fxdnoise'}) && ($wewe_1 =~ /$fltrnoise/i) ) {next;}
  $uwrds ++;
  $syllables = $wewe_1 =~ s/([^aeiou][aeiou])/$1/ig;
  if ($wewe_1 =~ /e\s*$/i) {$syllables--;}
  if ($wewe_1 =~ /y\s*$/i) {$syllables++;}
  if ($syllables >= 3) {$sylblwrds++;}
  $syllablestot += $syllables;
  if ($column == 0) {print "<TR>";}
  print "<TD>";
  print "<INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'>";
  print "$accessedwords{$word}: $word </TD>\n";
  if ($column++ >= 4) {print "</TR>\n"; $column = 0;}
}
print "</TABLE><P>\n";
print "<B>Accessed Unique Words:</B> $uwrds<P>\n";

print "<B><BIG>Alpha Sort</BIG></B>\n";
#print "<INPUT TYPE='radio' NAME='search' VALUE='' CHECKED> Search None<P>\n";
print "<TABLE>";
$column = 0;

foreach $word (sort keys %accessedwords) {
  $wewe = $word;
  $wewe =~ s/<[^<]+>//g;
  #$wewe =~ s/\s+$//;
  #$wewe =~ s/^\s+//;
  $wewe_1 = $word;
  $wewe_1 =~ s/<[^<]+>/ /g;
  if ( ($input{'fxdnoise'}) && ($wewe_1 =~ /$fltrnoise/i) ) {next;}
  if ($column == 0) {print "<TR>";}
  print "<TD>";
  print "<INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'>";
  print "$accessedwords{$word}: $word</TD>\n";
  if ($column++ >= 4) {print "</TR>\n"; $column = 0;}
}
print "</TABLE><P>\n";
print "<B>Accessed Unique Words:</B> $uwrds<HR>\n";

}

####################
sub accessed_patterns {


$columnwidth = 5;
$column = 0;

print "<P><A NAME='accessedpatternsfound'> </A><BIG><BIG><B>Accessed Patterns Found</B></BIG></BIG> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hideap' VALUE='CHECKED' $input{'hideap'}> Hide</SMALL>\n";
if ($input{'hideap'}) {return;}
print "<P>\n";

if (!%accessedpatterns) {print "No results to report.\n"; return;}

print "<CENTER><B><BIG>Number Sort</BIG></B>\n";

print "<TABLE CELLSPACING='2'>\n";
$table = "yes";
foreach $word (sort flipaccessedpatterns keys(%accessedpatterns)) {
   $wewe = $word;
   $wewe =~ s/<[^<]+>//g;
   $table = "rows";
   if ($column == 0) { print "<TR>\n";}
   $column++;
   print "<TD><INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'>";
   print "$accessedpatterns{$word} $word</TD>\n";
   if ($column > $columnwidth) {print "</TR>\n"; $column = 0;}
}
if ($table eq "rows") { 
   if ($column <= $columnwidth) {print "</TR>\n";} 
}
else {
   print "<TR><TD>no data</TD></TR>\n";
}
print "</TABLE></CENTER><P>\n";

$columnwidth = 5;
$column = 0;
print "<CENTER><B><BIG>Alpha Sort</BIG></B>\n";
#print "<INPUT TYPE='radio' NAME='search' VALUE='' CHECKED> Search None<P>\n";
print "<TABLE CELLSPACING='2'>\n";
$table = "yes";
foreach $word (sort keys(%accessedpatterns)) {
   $table = "rows";
   if ($column == 0) { print "<TR>\n";}
   $column++;
   $wewe = $word;
   $wewe =~ s/<[^<]+>//g;
   print "<TD><INPUT TYPE='checkbox' NAME='search' VALUE='$wewe'> ";
   print "$accessedpatterns{$word} $word</TD>\n";
   if ($column > $columnwidth) {print "</TR>\n"; $column = 0;}
}
if ($table eq "rows") { 
   if ($column <= $columnwidth) {print "</TR>\n";} 
}
else {
   print "<TR><TD>no data</TD></TR>\n";
}
print "</TABLE></CENTER><P>\n";

# keywords not found
print "<CENTER><B><BIG>Accessed Patterns Not Found</BIG></B><P>\n";

print "<TABLE CELLSPACING='2'>\n";
$table = "yes";
foreach $word (@allaccesspat) {
   $foundit = "no";
   foreach $searchword (sort keys(%accessedpatterns)) {
      if ($searchword =~ /$word/i) {
         $foundit = "yes"; 
         last;
      }
   }
   if ($foundit eq "no") {
         $table = "rows";
         if ($column == 0) { print "<TR>\n";}
         $column++;
         $wewe = $allaccesspatcolor{$word};
         print "<TD><FONT COLOR='$wewe'>$word</FONT></TD>\n";
         if ($column > $columnwidth) {print "</TR>\n"; $column = 0;}
   }
}

if ($table eq "rows") { 
   if ($column <= $columnwidth) {print "</TR>\n";} 
}
else {
   print "<TR><TD>no data</TD></TR>\n";
}
print "</TABLE></CENTER><P>\n";

}

####################
sub flipaccessedwords {$accessedwords{$b}<=>$accessedwords{$a};}
sub flipaccessedpatterns {$accessedpatterns{$b}<=>$accessedpatterns{$a};}

####################
sub metrics {

print "<P><HR><P>";

# report metrics
print "<A NAME='metrics'> </A><BIG><BIG><B>Metrics</B></BIG></BIG> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hidemetrics' VALUE='CHECKED' $input{'hidemetrics'}> Hide</SMALL>\n";

$lines = $count_all;

if (!$input{'hidemetrics'}) {
print "<P>\n";

print "<INPUT TYPE='checkbox' NAME='metricsave' VALUE='CHECKED' $input{'metricsave'}> <A HREF='help.html#Save Metrics' TARGET='HELP'>Save Metrics</A> ";
if ( ($filestatus) || ($incfn{'upfile'}) ) {print "with analysis run <SMALL>$filestatus $incfn{'upfile'} $month/$mday/$year $hour:$min:$sec</SMALL> ";}
print "<A HREF='previous-analysis/metrics.xls' TARGET='metrics'>Appended Metrics File</A> <P>";
if (!%metric) {print "No results to report."; return;}


print "<TABLE><TR VALIGN='TOP'><TD>
<B>Total Lines:</B> $lines<BR>
<B>Blank Lines:</B> $count_blk<BR>
<NOBR><B>Non Blank Lines:</B> $count_nb</NOBR><BR>
<B>Imperatives:</B> $imperative<BR>
<B>Shalls:</B> $shall<BR>
<B>Wills:</B> $will<BR>
<B>IsReq:</B> $isreq<P>
</TD><TD>";

if ($input{'metricsave'}) {
close(METRICS);
open(METRICS,">>previous-analysis/metrics.xls") || print "<FONT COLOR='RED'>Unable to save metrics, close anything viewing the file.</FONT><P>";

select(METRICS);
print "
$filestatus $incfn{'upfile'}\t$month/$mday/$year\t$hour:$min:$sec
Total Lines\t$lines
Blank Lines\t$count_blk
Non Blank Lines\t$count_nb
Imperatives\t$imperative
Shalls\t$shall
Wills\t$will
IsReq\t$isreq
";
select(STDOUT);
}

if ( ($count_nb) && ($url =~ /sat/) ) {
   $p_doctype = int(100*$imperative/$count_nb);
   if ($p_doctype > 50) {
      print "<FONT COLOR='GREEN'><B>Message:</B></FONT> ";
      print "This document is $p_doctype% imperatives suggesting you have a specification. ";
      if (($p_doctype >= 50) && ($p_doctype < 80)) {
         print "But, you should move some of the descriptive text to your analysis or design documents. ";
      }
      if (($p_doctype >= 80) && ($p_doctype < 90)) {
         print "There is some descriptive text that you may want to push to your analysis or design documentation. ";
      }
      if (($p_doctype >= 90) && ($p_doctype <= 100)) {
         print "If you have descriptive text in your analysis and design documentation, then nice job. ";
         print "If you have NO descriptive text in your analysis and design documentation, then you probably have a problem. ";
      }
   }
   if ($p_doctype <= 50) {
      print "<FONT COLOR='RED'><B>Message:</B></FONT> ";
      print "This document is $p_doctype% imperatives suggesting you do not have a specification. ";
      print "Is this an analysis document? ";
      print "If you are trying to find requirements in this document try the Key Requirements Service. ";
   }

}
else {
   print "<FONT COLOR='RED'><B>Message:</B></FONT> ";
   print "These metrics are what allow you to compare different documents and different analysis runs. ";
   print "Consider moving the numbers into a spreadsheet for visualization. ";
   print "Counts of Shalls, Wills, IsReq, and Imperatives are hardcoded into the tool. ";
   print "You have the ability to enter a Norm value, which can be surfaced after multiple analysis sessions. ";
}
print "</TD></TR></TABLE>\n";

if ($input{'metricsave'}) {
select(METRICS);
print "Percent Imperatives\t$p_doctype\n";
select(STDOUT);
}

print "<P>";
print "<TABLE BORDER='2'>";
print "<TR>
<TD> <B>Item</B> </TD>
<TD> <B>Risk</B> </TD>
<TD> <B>Count</B> </TD>
<TD> <B>Children</B> </TD>
<TD> <B>% lines</B> </TD>
<TD> <B>% imperative</B> </TD>
<TD> <B>% shall</B> </TD>
<TD> <B>% will</B> </TD>
<TD> <B>% isreq</B> </TD>
<TD> <B>% Norm</B> </TD>
</TR>\n";

if ($input{'metricsave'}) {
select(METRICS);
print "Item\tRisk\tCount\tChildren\t% lines\t% imperative\t% shall\t% will\t% isreq\t% Norm\n";
select(STDOUT);
}

foreach $metric (sort keys %metric) {

   # find values in rules based on metrics
   $norm = "";
   $risk = "";
  for ($is = 1; $is <= 20; ++$is) {
      if (!$input{"srvcname$is"}) {last;}
      if ($input{"srvc$is"} !~ /CHECKED/i) {next;}
      $wewe = $metric;
      $wewe =~ s/ <.*>//g;
      $s = $input{"srvcpui$is"};
      $s =~ s/rta//;
      for ($i = 1; $i <= 99; ++$i) {
         if (!$input{"name$i$s"}) {last;}
         if ($wewe eq $input{"name$i$s"}) {
            if ($input{"norm$i$s"}) {$norm = $input{"norm$i$s"};}
            if ($input{"risk$i$s"}) {$risk = $input{"risk$i$s"};}
         }
      }
   }

   $trig++;
   $count = $metric{$metric} - 1;
   if ($metric =~ /Duplicate Consecutive|Duplicate Text|Duplicate Imperative/) {$count++;}
   if ($count == 0) {
      $count = "";
      $ntrig++;
   }

   $p_lines = "";
   $p_imperative = "";
   $p_shall = "";
   $p_will  = "";
   $p_isreq = "";

   if ( ($count) && ($lines) ) {$p_lines  = int(100*$count*100/$lines)/100;}
   if ( ($count) && ($imperative) ) {$p_imperative = int(100*$count*100/$imperative)/100;}
   if ( ($count) && ($shall) )  {$p_shall = int(100*$count*100/$shall)/100;}
   if ( ($count) && ($will) )   {$p_will  = int(100*$count*100/$will)/100;}
   if ( ($count) && ($isreq) )  {$p_isreq = int(100*$count*100/$isreq)/100;}

   if ($p_lines > 100) {$p_lines = "";}
   if ($p_imperative > 100) {$p_imperative = "";}
   if ($p_shall > 100) {$p_shall = "";}
   if ($p_will > 100) {$p_will = "";}
   if ($p_isreq > 100) {$p_isreq = "";}

   $metric_1 = $metric;
   $metric_1 =~ s/<.*>//g;
   print "<TR>
   <TD> <A HREF='#$metric_1'>$metric</A> </TD>
   <TD> <P ALIGN=Right>$risk </TD>
   <TD> <P ALIGN=Right>$count </TD>
   <TD> <P ALIGN=Right>$metric_child{$metric}</TD>
   <TD> <P ALIGN=Right>$p_lines </TD>
   <TD> <P ALIGN=Right>$p_imperative </TD>
   <TD> <P ALIGN=Right>$p_shall </TD>
   <TD> <P ALIGN=Right>$p_will </TD>
   <TD> <P ALIGN=Right>$p_isreq </TD>
   <TD> <P ALIGN=Right>$norm </TD>
   </TR>\n";

   if ($input{'metricsave'}) {
   select(METRICS);
   print "$metric_1\t$count\t$metric_child{$metric}\t$p_lines\t$p_imperative\t$p_shall\t$p_will\t$p_isreq\t$norm\n";
   select(STDOUT);
   }

}
print "</TABLE><P>";

if ($trig) {$p_trig = int(($trig-$ntrig)*100/$trig);}

$ttrig = $trig - $ntrig;
print "<B>Rules Total</B> $trig<BR>\n";
print "<B>Rules Triggered</B> $ttrig<BR>\n";
print "<B>Rules Not Triggered</B> $ntrig<BR>\n";
print "<B>Percent of Rules Triggered</B> $p_trig%<P>\n";

if ($input{'metricsave'}) {
select(METRICS);
print "Rules Total\t$trig
Rules Triggered\t$ttrig
Rules Not Triggered\t$ntrig
Percent of Rules Triggered\t$p_trig%
";
select(STDOUT);
}

}

print "<P><A NAME='readinglevel'> </A><BIG><BIG><B>Reading Level</B></BIG></BIG> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hiderl' VALUE='CHECKED' $input{'hiderl'}> Hide</SMALL>\n";

if (!$input{'hiderl'}) {
print "<P>\n";

if ($lines) {$polysyllabic = int((30/$lines)*$sylblwrds);}
$rdlvl = 4;
if ($polysyllabic > 2) {$rdlvl = 5;}
if ($polysyllabic > 6) {$rdlvl = 6;}
if ($polysyllabic > 12) {$rdlvl = 7;}
if ($polysyllabic > 20) {$rdlvl = 8;}
if ($polysyllabic > 30) {$rdlvl = 9;}
if ($polysyllabic > 42) {$rdlvl = 10;}
if ($polysyllabic > 56) {$rdlvl = 11;}
if ($polysyllabic > 72) {$rdlvl = 12;}
if ($polysyllabic > 90) {$rdlvl = 13;}
if ($polysyllabic > 110) {$rdlvl = 14;}
if ($polysyllabic > 132) {$rdlvl = 15;}
if ($polysyllabic > 182) {$rdlvl = 16;}
if ($polysyllabic > 210) {$rdlvl = 17;}
if ($polysyllabic > 240) {$rdlvl = 18;}
if (!$sylblwrds) {$rdlvl = "No reading level is available. Select any rule option and check: Count Accessed Words <U>or</U> use a Reading Level Service which has checked: Count Accessed Words.";}

print "Disabling the noise filter may reduce the reading level. ";
print "Re-run the report to capture metrics for both instances.<P>";
print "<B>Accessed Unique Words:</B> $uwrds<BR>\n";
print "<B>Accessed Unique Syllables:</B> $syllablestot<BR>\n";
print "<B>Words with 3+ Syllables:</B> $sylblwrds<BR>\n";
print "<B>Polysyllabic Count:</B> $polysyllabic<BR>\n";
print "<B>Reading Level:</B> $rdlvl<P>";

if ($input{'metricsave'}) {
select(METRICS);
print "Accessed Unique Words\t$uwrds
Accessed Unique Syllables\t$syllablestot
Words with 3+ Syllables\t$sylblwrds
Polysyllabic Count\t$polysyllabic
Reading Level\t$rdlvl
";
select(STDOUT);
}

}

}

#####################
sub shape {

print "<P><A NAME='shape'> </A><BIG><BIG><B>Document Shape</B></BIG></BIG> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hideds' VALUE='CHECKED' $input{'hideds'}> Hide</SMALL>\n";

if ($input{'hideds'}) {return};
print "<P>\n";

if (!%metric) {print "No results to report."; return;}

print "The number of children at a particular level translate to a document shape. ";
print "There are diffrent document shapes and each have implications. ";
print "The document shapes are: random, rectangle, pyramid, inverted pyramid, trapazoid and diamond.\n";
print "<P>\n";

# find max value
foreach $metric (sort keys %metric) {
   if ($metric_child{$metric} > $max) {$max = $metric_child{$metric};}
}
if (!$max) {
   print "There are no child counts. ";
   print "Try disabling all services except for the service that has checked: Count Accessed Words.<P>";
   return;
}

print "<CENTER><TABLE><TR><TD>\n";
print "<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='0'>";
print "<TR>
<TD><B> <CENTER>Item</CENTER></B></TD>
<TD><IMG SRC='spacer.gif' WIDTH='10' HEIGHT='1'></TD>
<TD><B><CENTER>Count</CENTER></B></TD>
<TD><IMG SRC='spacer.gif' WIDTH='10' HEIGHT='1'></TD>
<TD><B><CENTER>Prcnt</CENTER></B></TD>
<TD><IMG SRC='spacer.gif' WIDTH='10' HEIGHT='1'></TD>
<TD><B><CENTER>Shape</CENTER></B></TD>
</TR>\n";
foreach $metric (sort keys %metric) {

   $p_metric_child = "";
   if ($metric_child{$metric}) {$p_metric_child = int($metric_child{$metric}*100/$max);}
   $size = $p_metric_child * 2;

   print "<TR>
   <TD> $metric </TD>
   <TD></TD>
   <TD><P ALIGN=Right>$metric_child{$metric}</TD>
   <TD></TD>
   <TD><P ALIGN=Right>$p_metric_child</TD>
   <TD></TD>
   <TD><CENTER><IMG SRC='bar.gif' WIDTH='$size' HEIGHT='20'><CENTER></TD>
   </TR>\n";
}
print "</TR></TABLE>\n";
print "</TD></TR></TABLE></CENTER>\n";

}

####################
sub comments {

print "<P><A NAME='comments'> </A><BIG><BIG><B>Services and Triggered Rule Comments</B></BIG></BIG> ";
print "<SMALL><INPUT TYPE='checkbox' NAME='hidecmts' VALUE='CHECKED' $input{'hidecmts'}> Hide</SMALL>\n";

if ($input{'hidecmts'}) {return;}
print "<P>\n";

for ($is = 1; $is <= 20; ++$is) {
$sr = "";
$count = 0;

foreach $metric (sort keys %metric) {

   if (!$input{"srvcname$is"}) {last;}
   if ($input{"srvc$is"} !~ /CHECKED/i) {next;}

   $metric =~ s/ <.*>//g;

   $s = $input{"srvcpui$is"};
   $s =~ s/rta//;

   if ( ($input{"srvc$is"}) && (!$sr) ) {
      $sr = 1;
      print "<B>$input{\"srvcname$is\"}:</B> $input{\"srvcdescrip$s\"}<P>";
   }

   for ($i = 1; $i <= 99; ++$i) {
      
      if (!$input{"name$i$s"}) {last;}
      if ($metric eq $input{"name$i$s"}) {
         $count++;
         print " . . . <A NAME='$input{\"name$i$s\"}'><B>$count.</B></A> ";
         print "<FONT COLOR='$input{\"color$i$s\"}'><B>$input{\"name$i$s\"}</B></FONT> ";
         if (!$input{"comment$i$s"}) {print "No Comment Text in this rule.";}
         print "$input{\"comment$i$s\"} \n";

         print "<BR> . . . . . . <SMALL><A HREF='http:help.html#Rules' TARGET='help'>Rule Summary</A> \n";
         #print "M: -$metric- R: -$input{\"name$i$s\"}- $i $s ";

         $name = "name";
         if ( $input{"$name$i$s"} ) {print "<B>Name:</B> $input{\"$name$i$s\"} ";}
         $name = "color";
         if ( $input{"$name$i$s"} ) {print "<B>Color:</B> $input{\"$name$i$s\"} ";}
         $name = "norm";
         if ( $input{"$name$i$s"} ) {print "<B>Norm Metric:</B> $input{\"$name$i$s\"} ";}
         $name = "case";
         if ( $input{"$name$i$s"} ) {print "<B>Case Sensitive :</B> $input{\"$name$i$s\"} ";}
         $name = "access";
         if ( $input{"$name$i$s"} ) {print "<B>Access Object:</B> $input{\"$name$i$s\"} ";}
         $name = "accessm1";
         if ( $input{"$name$i$s"} ) {print "<B>Previous Object:</B> $input{\"$name$i$s\"} ";}
         $name = "accessp1";
         if ( $input{"$name$i$s"} ) {print "<B>Next Object:</B> $input{\"$name$i$s\"} ";}
         $name = "reject";
         if ( $input{"$name$i$s"} ) {print "<B>Reject Object:</B> $input{\"$name$i$s\"} ";}
         $name = "hideobj";
         if ( $input{"$name$i$s"} ) {print "<B>Hide Accessed Objects:</B> $input{\"$name$i$s\"} ";}
         $name = "showchld";
         if ( $input{"$name$i$s"} ) {print "<B>Show Child Objects:</B> $input{\"$name$i$s\"} ";}
         $name = "countchld";
         if ( $input{"$name$i$s"} ) {print "<B>Count Child Objects:</B> $input{\"$name$i$s\"} ";}
         $name = "countpat";
         if ( $input{"$name$i$s"} ) {print "<B>Count Accessed Patterns:</B> $input{\"$name$i$s\"} ";}
         $name = "countacc";
         if ( $input{"$name$i$s"} ) {print "<B>Count Accessed Words:</B> $input{\"$name$i$s\"} ";}
         $name = "countrej";
         if ( $input{"$name$i$s"} ) {print "<B>Count Rejected Words:</B> $input{\"$name$i$s\"} ";}

         if ($s =~ /rptdup/) {
            $name = "mask1";
            if ( $input{"$name$s"} ) {print "<B>Mask Patterns:</B> $input{\"$name$s\"} ";}
         }

         print "</SMALL><P>\n";
      }

   }

}

}
print "<P>\n";

}

####################
sub default_services {

if (!$input{'srvcname1'}) {

$input{'srvcname1'}  = "My Highlighter Pens - Default Service";
$input{'srvc1'}      = "CHECKED";
$input{"rptrules1"}  = "CHECKED";
$input{"rptrulesc1"} = "";
$input{'srvcpui1'}   = "rta";

$input{'srvcname2'} = "Find Duplicate Objects";
$input{'srvc2'}     = "";
$input{"rptrules2"}  = "";
$input{"rptrulesc2"} = "";
$input{'srvcpui2'}  = "rptdup";

}

}

####################
sub default_rules {

# Default Rules
#$s = "rta";
$s = "";

if (!$input{'name1'}) {
#if (!$input{'srvcname1'}) {

$input{"srvcdescrip$s"}  = "This is your first rule in your first service. ";
$input{"srvcdescrip$s"} .= "Think of this as your highlighter pen or ";
$input{"srvcdescrip$s"} .= "a really advanced search engine option. ";

$i = 1;
$input{"rpt$i$s"}        = "CHECKED";
$input{"name$i$s"}     = "Red Highlighter - Generic Search";
$input{"color$i$s"}    = "RED";
$input{"access$i$s"}   = "Just type a keyword for a search";
$input{"reject$i$s"}   = "Type other words to reject finds";
$input{"comment$i$s"} .= "This is my first rule. Its a simple keyword search. ";
$input{"comment$i$s"} .= "Try these colors: ";
$input{"comment$i$s"} .= "RED GREEN BLUE PURPLE MAROON NAVY ORANGE";
$input{"hideobj$i$s"}  = "";
$input{"count$i$s"}    = "CHECKED";
$input{"noise$i$s"}    = "CHECKED";

$i = 2;
$input{"rpt$i$s"}        = "CHECKED";
$input{"name$i$s"}     = "Green Highligter - Generic Search";
$input{"color$i$s"}    = "GREEN";
$input{"access$i$s"}   = "Just type a keyword for a search";
$input{"reject$i$s"}   = "Type other words to reject finds";
$input{"comment$i$s"} .= "This is my second rule. Its a simple keyword search. ";
$input{"comment$i$s"} .= "Try these colors: ";
$input{"comment$i$s"} .= "RED GREEN BLUE PURPLE MAROON NAVY ORANGE";
$input{"hideobj$i$s"}  = "";
$input{"count$i$s"}    = "CHECKED";
$input{"noise$i$s"}    = "CHECKED";
}

# Find Duplicate Objects
$s = rptdup;
if (!$input{"name1$s"}) {
#if (!$input{"srvcname2"}) {
$input{"srvcdescrip$s"}  .= "This looks for duplicate objects. ";
$input{"srvcdescrip$s"}  .= "If a mask pattern is entered then similar objects will be ";
$input{"srvcdescrip$s"}  .= "shown as duplicates, if the mask pattern is good. ";
$input{"name1$s"}     = "Duplicates";
$input{"accessaw$s"}   = "nnoonnee";
$input{"mask1$s"}     = "allow a|user.?|permit.?";
$input{"rpt1$s"}      = "CHECKED";
}

}

####################
sub ReadParse {

  local (*in) = shift if @_;    # CGI input
  local (*incfn,                # Client's filename (may not be provided)
	   *inct,                 # Client's content-type (may not be provided)
	   *insfn) = @_;          # Server's filename (for spooled files)
  local ($len, $type, $meth, $errflag, $cmdflag, $got, $name);
	
  binmode(STDIN);   # we need these for DOS-based systems
  binmode(STDOUT);  # and they shouldn't hurt anything else 
  binmode(STDERR);

  # Get several useful env variables
  $type = $ENV{'CONTENT_TYPE'};
  $len  = $ENV{'CONTENT_LENGTH'};
  $meth = $ENV{'REQUEST_METHOD'};
  
  if ($len > $g_maxdata) { #'
      &CgiDie("cgi-lib.pl: Request to receive too much data: $len bytes\n");
  }
  
  if (!defined $meth || $meth eq '' || $meth eq 'GET' || 
      $meth eq 'HEAD' ||
      $type eq 'application/x-www-form-urlencoded') {
    local ($key, $val, $i);
	
    # Read in text
    if (!defined $meth || $meth eq '') {
      $in = $ENV{'QUERY_STRING'};
      $cmdflag = 1;  # also use command-line options
    } elsif($meth eq 'GET' || $meth eq 'HEAD') {
      $in = $ENV{'QUERY_STRING'};
    } elsif ($meth eq 'POST') {
        if (($got = read(STDIN, $in, $len) != $len))
	  {$errflag="Short Read: wanted $len, got $got\n";};
    } else {
      &CgiDie("cgi-lib.pl: Unknown request method: $meth\n");
    }

    @in = split(/[&;]/,$in); 
    push(@in, @ARGV) if $cmdflag; # add command-line parameters

    foreach $i (0 .. $#in) {
      # Convert plus to space
      $in[$i] =~ s/\+/ /g;

      # Split into key and value.  
      ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

      # Convert %XX from hex numbers to alphanumeric
      $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
      $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

      # Associate key and value
      $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
    }

  } elsif ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    # for efficiency, compile multipart code only if needed
    $errflag = !(eval <<'END_MULTIPART');

    local ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
    local ($bpos, $lpos, $left, $amt, $fn, $ser);
    local ($bufsize, $maxbound, $writefiles) = 
      ($g_bufsize, $g_maxbound, $g_writefiles);

    # The following lines exist solely to eliminate spurious warning messages
    $buf = ''; 

    ($boundary) = $type =~ /boundary="([^"]+)"/; #";   # find boundary
    ($boundary) = $type =~ /boundary=(\S+)/ unless $boundary;
    &CgiDie ("Boundary not provided: probably a bug in your server") 
      unless $boundary;
    $boundary =  "--" . $boundary;
    $blen = length ($boundary);

    if ($ENV{'REQUEST_METHOD'} ne 'POST') {
      &CgiDie("Invalid request method for  multipart/form-data: $meth\n");
    }

    if ($writefiles) {
      local($me);
      stat ($writefiles);
      $writefiles = "/tmp" unless  -d _ && -w _;
      $writefiles .= "/$g_filepre"; 
    }

    $left = $len;
   PART: # find each part of the multi-part while reading data
    while (1) {
      die $@ if $errflag;

      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ?  $bufsize+$maxbound-length($buf): $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;

      $in{$name} .= "\0" if defined $in{$name}; 
      $in{$name} .= $fn if $fn;

      $name=~/([-\w]+)/;  # This allows $insfn{$name} to be untainted
      if (defined $1) {
        $insfn{$1} .= "\0" if defined $insfn{$1}; 
        $insfn{$1} .= $fn if $fn;
      }
 
     BODY: 
      while (($bpos = index($buf, $boundary)) == -1) {
        if ($left == 0 && $buf eq '') {
	  foreach $value (values %insfn) {
           unlink(split("\0",$value));
	  }
	  &CgiDie("cgi-lib.pl: reached end of input while seeking boundary " .
		  "of multipart. Format of CGI input is wrong.\n");
        }
        die $@ if $errflag;
        if ($name) {  # if no $name, then it's the prologue -- discard
          if ($fn) { print FILE substr($buf, 0, $bufsize); }
          $in{$name} .= substr($buf, 0, $bufsize);
        }
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
	  die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      if (defined $name) {  # if no $name, then it's the prologue -- discard
        if ($fn) { print FILE substr($buf, 0, $bpos-2); }
        $in{$name} .= substr($buf, 0, $bpos-2); # kill last \r\n
      }
      close (FILE);
      last PART if substr($buf, $bpos + $blen, 2) eq "--";
      substr($buf, 0, $bpos+$blen+2) = '';
      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ? $bufsize+$maxbound-length($buf) : $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;

     undef $head;  undef $fn;
     HEAD:
      while (($lpos = index($buf, "\r\n\r\n")) == -1) { 
        if ($left == 0  && $buf eq '') {
	  foreach $value (values %insfn) {
           unlink(split("\0",$value));
	  }
	  &CgiDie("cgi-lib: reached end of input while seeking end of " .
		  "headers. Format of CGI input is wrong.\n$buf");
        }
        die $@ if $errflag;
        $head .= substr($buf, 0, $bufsize);
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
        die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      $head .= substr($buf, 0, $lpos+2);

      push (@in, $head);
      @heads = split("\r\n", $head);

      ($cd) = grep (/^\s*Content-Disposition:/i, @heads);
      ($ct) = grep (/^\s*Content-Type:/i, @heads);

      ($name) = $cd =~ /\bname="([^"]+)"/i; #"; 
      ($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;  

      ($fname) = $cd =~ /\bfilename="([^"]*)"/i; #"; # filename can be null-str
      ($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
      $incfn{$name} .= (defined $in{$name} ? "\0" : "") . 
        (defined $fname ? $fname : "");

      ($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
      ($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
      $inct{$name} .= (defined $in{$name} ? "\0" : "") . $ctype;

      if ($writefiles && defined $fname) {
        $ser++;
	  $fn = $writefiles . ".$$.$ser";
	  open (FILE, ">$fn") || &CgiDie("Couldn't open $fn\n");
        binmode (FILE);  # write files accurately
      }
      substr($buf, 0, $lpos+4) = '';

      undef $fname;
      undef $ctype;
    }

1;
END_MULTIPART
    if ($errflag) {
      local ($errmsg, $value);
      $errmsg = $@ || $errflag;
      foreach $value (values %insfn) {
        unlink(split("\0",$value));
      }
      &CgiDie($errmsg);
    } else {
      # everything's ok.
    }
  } else {
    &CgiDie("cgi-lib.pl: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n");
  }

return ($errflag ? undef :  scalar(@in));
}


####################
sub CgiDie {
  local (@msg) = @_;
  local ($i,$name);
  if (!@msg) {
    @msg = ("Error: script $name encountered fatal error\n");
  };
  print "<h1>$msg[0]</h1>\n";
  foreach $i (1 .. $#msg) {
    print "<p>$msg[$i]</p>\n";
  }
  die @msg;
}

####################
sub PrintVariables {
  local (*in) = @_ if @_ == 1;
  local (%in) = @_ if @_ > 1;
  local ($out, $key, $output);

  $output =  "\n<dl compact>\n";
  foreach $key (sort keys(%in)) {
    foreach (split("\0", $in{$key})) {
      ($out = $_) =~ s/\n/<br>\n/g;
      $output .=  "<dt><b>-$key-</b>\n <dd>:<i>-$out-</i>:<br>\n";
    }
  }
  $output .=  "</dl>\n";

  return $output;
}

####################
sub get_date {

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

$month = ($mon + 1);

if ($sec  < 10) {$sec  = "0$sec";}
if ($min  < 10) {$min  = "0$min";}
if ($hour < 10) {$hour = "0$hour";}
if ($month  < 10) {$month  = "0$month";}
if ($mday < 10) {$mday = "0$mday";}

$year = $year - 100;
$year = "0$year";

$date = "$month/$mday/$year, $hour\:$min\:$sec";

}

####################
sub log {

# Lic key
open(KEY,"pck.txt");
@key = <KEY>;
close(KEY);
$key[0] =~ s/\n//;
$keydate = $key[0];

$syllables = $key[0] =~ s/([^aeiou][aeiou])/$1/ig;
$length = length($key[0]);

$key[0] =~ s/\W/0/ig;
$key[0] =~ s/a/1/ig;
$key[0] =~ s/b/2/ig;
$key[0] =~ s/c/3/ig;
$key[0] =~ s/d/4/ig;
$key[0] =~ s/e/5/ig;
$key[0] =~ s/f/6/ig;
$key[0] =~ s/g/7/ig;
$key[0] =~ s/h/8/ig;
$key[0] =~ s/i/9/ig;
$key[0] =~ s/j/10/ig;
$key[0] =~ s/k/11/ig;
$key[0] =~ s/l/12/ig;
$key[0] =~ s/m/13/ig;
$key[0] =~ s/n/14/ig;
$key[0] =~ s/o/15/ig;
$key[0] =~ s/p/16/ig;
$key[0] =~ s/q/17/ig;
$key[0] =~ s/u/18/ig;
$key[0] =~ s/r/19/ig;
$key[0] =~ s/s/20/ig;
$key[0] =~ s/t/21/ig;
$key[0] =~ s/u/22/ig;
$key[0] =~ s/v/23/ig;
$key[0] =~ s/w/24/ig;
$key[0] =~ s/x/25/ig;
$key[0] =~ s/y/26/ig;
$key[0] =~ s/z/27/ig;

$phrase_1 = $key[0];
$phrase_1 =~ s/^(.{1,12})(.*)/$1/;

$key[0] =~ s/(..)/$1 /g;
@phrase = split(/ /,$key[0]);
foreach $word (@phrase) {$value += $word;}

$ckey  = ($phrase_1 + 3115612554 - 4*$value*$value*$value*$length - $syllables*$value*$value*$value) * ($syllables + 1) + $prod;

if ($ckey != $key[1]) {
   $status = `copy log.dat log$month$mday$year$hour$min$sec.dat`;
   #print "$status";
   $file = "log.dat";
   $status = unlink $file;
   #print "$status<P>";

   if (!$input{'licensee'}) {$inputlicensee = "book063113";}
   if (!$input{'key'}) {$inputkey = 435774035730 + $prod;}

   print "<H2>Please Enter The Following Information</H2><P>\n";
   print "If you purchased this application please enter your information.<BR>\n";
   print "If you are interested in a demo, your analysis is limited in time and results.<BR>\n";
   print "If you are using a book key, you can use this tool but please consider buying our book.<BR>\n";
   print "The demo and book keys do expire and if you have an old key, "; 
   print "please contact <A HREF='http://www.cassbeth.com'>www.cassbeth.com</A><BR>\n";
   print "more demo keys <A HREF='http://www.cassbeth.com/keys.html'>www.cassbeth.com/keys.html</A><P>\n";
   print "<FORM method='POST' ENCTYPE='multipart/form-data' ACTION='$script'>\n";
   print "<INPUT TYPE='text' NAME='licensee' VALUE='$inputlicensee' SIZE='20'> Licensee\n";
   print "<INPUT TYPE='text' NAME='key' VALUE='$inputkey' SIZE='20'> Product Code\n";
   print "<P><INPUT TYPE='submit' VALUE='Next >>'>\n";
   print "</FORM>\n";
   if ( ($input{'licensee'}) && ($input{'key'}) ) {
      open(SKEY,">pck.txt");
      print SKEY "$input{'licensee'}\n";
      print SKEY "$input{'key'}\n";
      close(SKEY);
      if ($input{'licensee'} =~ /demo/i) {

         if ($url =~ /sat/) {$lui = "../../Program Files/clpsbt.dat";}
         if ($url =~ /gda/) {$lui = "../../Program Files/clpgdb.dat";}
         if ($url =~ /cla/) {$lui = "../../Program Files/clpclb.dat";}
         if ($url =~ /lat/) {$lui = "../../Program Files/clplbt.dat";}
         if ($url =~ /lda/) {$lui = "../../Program Files/clpldb.dat";}
         if ($url =~ /cat/) {$lui = "../../Program Files/clpcbt.dat";}
         if ($url =~ /pla/) {$lui = "../../Program Files/clpplb.dat";}
         if ($url =~ /dev/) {$lui = "../../Program Files/clpdfv.dat";}
         if ($url =~ /mta/) {$lui = "../../Program Files/clpmtb.dat";}
         if ($url =~ /dva/) {$lui = "../../Program Files/clpdvb.dat";}

         print "<P>This is a demo install ";
         open(CLP,"$lui");
         $clp = <CLP>;
         close(CLP);
         if (!$clp) {
            open(CLP,">$lui");
            $clp = <CLP>;
            print CLP "1";
            close(CLP);
         }
      }
      print "<P>$input{'licensee'} ";
      print "$input{'key'}<P>\n";
      print "Please press next again to confirm<P>\n";
   }
   exit;
}

# Lic agreement
stat("log.dat");
if (! -e _) {
   if ($input{'license'}) {
      if (!open(LOG,">>log.dat")) {print "Content-type: text/html\n\n"; print "Couldn't open log.dat\n"; exit;}
      print LOG "$ENV{'REMOTE_HOST'}, $ENV{'REMOTE_IDENT'}, $date, , , USER HAS AGREED TO LICENSE AGREEMENT, , $ENV{'CONTENT_LENGTH'}, , , , GET, $ENV{'DOCUMENT_URI'}, $ENV{'HTTP_USER_AGENT'}, $ENV{'HTTP_REFERER'}, , ,\n";
      close (LOG);
      print "<B>Thank You for buying CassBeths' Product $toolname<P><A HREF='$url/index.html'>Start $toolname Now</A></B>";
      exit;
   }
   print "<H2>Please Read The Following License Agreement</H2><P>";
   if (!open(LIC,"license.txt")) {print "Content-type: text/html\n\n"; print "Couldn't open License Agreement\n"; exit;}
   print "<FORM method='POST' ENCTYPE='multipart/form-data' ACTION='$script'>\n";
   print "<TEXTAREA NAME='licensewin' WRAP=VIRTUAL ROWS='10' COLS='60'>";
   while (<LIC>) {
      print "$_";
   }
   print "</TEXTAREA><P>\n";
   print "<P>\n";
   print "<INPUT TYPE='checkbox' NAME='license' VALUE='CHECKED'> ";
   print "Yes, I agree with all the terms and conditions of the license agreement.\n";
   print "<P><INPUT TYPE='submit' VALUE='Next >>'>\n";
   print "</FORM>\n";
   close (LOG);
   exit;
}

# Lic expiration
($month1,$mday1,$year1) = $keydate =~ m#(\d\d)(\d\d)(\d\d)$#o;

$agf = $year1*365+$month1*30+$mday1;
$agn = $year*365+$month*30+$mday;
$exp = $agf-$agn;

#if ($year > 8) {$app = "Your Executable is too old."; $exp = -1;}
if ($exp < 0) {
   print "Sorry your License expired. $app<P>\n";
   print "For your convenience the Engine has been removed.<P>\n";
   print "Please visit <A HREF='http://www.cassbeth.com'>www.cassbeth.com</A> and consider buying $tui.<P>";

   $status = `copy pck.txt pck$month$mday$year$hour$min$sec.txt`;
   print "$status";
   $file = "pck.txt";
   $status = unlink $file;
   print "$status<BR>";

   $status = `copy log.dat log$month$mday$year$hour$min$sec.dat`;
   print "$status";
   $file = "log.dat";
   $status = unlink $file;
   print "$status<P>";

   exec("exp.cgi");

}
if ($exp < 15) {
   $demo = "<B><BIG>This License will expire in $exp days <A HREF='$script?upgrade=y'>Upgrade Now</A></BIG></B>";
}

if($input{'upgrade'}) {
   print "We are now ready for Upgrade >> <A HREF='$script'>Upgrade Now</A><P>";
   $status = `copy pck.txt pck_txt.tmp`;
   $status = `copy log.dat log_dat.tmp`;
   unlink "pck.txt";
   unlink "log.dat";
   exit;
}


# log
if (!open(LOG,">>log.dat")) {print "Content-type: text/html\n\n"; print "Couldn't open log.dat\n"; exit;}
print LOG "$ENV{'REMOTE_HOST'}, $ENV{'REMOTE_IDENT'}, $date, , , cassbeth $demo, , $ENV{'CONTENT_LENGTH'}, , , , GET, $ENV{'DOCUMENT_URI'}, $ENV{'HTTP_USER_AGENT'}, $ENV{'HTTP_REFERER'}, , ,\n";
close (LOG);

}

1; #return true 

